Ubuntu

Slow Wireless Connection in Intel 3945abg

Reported by Errico Picchiarelli on 2010-08-20
616
This bug affects 116 people
Affects Status Importance Assigned to Milestone
Linux
Won't Fix
High
linux (Fedora)
Unknown
Unknown
linux (Ubuntu)
Medium
Andy Whitcroft
Maverick
Medium
Andy Whitcroft

Bug Description

With latest daily-live Maverick (2010-08-20), my wireless connection with Intel 3945abg never go over 3mbps speed.
I try this in local lan and in internet.
It seems like a regression about iwl3945 driver, i had a similar problem with older kernel where wireless speed was limited to 1mbps, with k/ubuntu 10.04 and 2.6.32 kernel this problem was disappear.

Some information:
lsb_release -rd:
Description: Ubuntu maverick (development branch)
Release: 10.10

uname -a:
Linux ubuntu 2.6.35-16-generic #22-Ubuntu SMP Tue Aug 17 02:21:03 UTC 2010 x86_64 GNU/Linux

dmesg | grep 3945:

[ 27.977578] iwl3945: Intel(R) PRO/Wireless 3945ABG/BG Network Connection driver for Linux, in-tree:s
[ 27.977583] iwl3945: Copyright(c) 2003-2010 Intel Corporation
[ 27.977678] iwl3945 0000:02:00.0: PCI INT A -> GSI 17 (level, low) -> IRQ 17
[ 27.977693] iwl3945 0000:02:00.0: setting latency timer to 64
[ 28.043199] iwl3945 0000:02:00.0: Tunable channels: 13 802.11bg, 23 802.11a channels
[ 28.043205] iwl3945 0000:02:00.0: Detected Intel Wireless WiFi Link 3945ABG
[ 28.043366] iwl3945 0000:02:00.0: irq 43 for MSI/MSI-X
[ 28.185681] phy0: Selected rate control algorithm 'iwl-3945-rs'
[ 28.523764] iwl3945 0000:02:00.0: loaded firmware version 15.32.2.9

iwconfig:
wlan0 IEEE 802.11abg ESSID:"Dorema"
          Mode:Managed Frequency:2.472 GHz Access Point: 00:1A:92:11:1C:C7
          Bit Rate=54 Mb/s Tx-Power=15 dBm
          Retry long limit:7 RTS thr:off Fragment thr:off
          Power Management:off
          Link Quality=68/70 Signal level=-42 dBm
          Rx invalid nwid:0 Rx invalid crypt:0 Rx invalid frag:0
          Tx excessive retries:0 Invalid misc:0 Missed beacon:0

My access point is Asus WL-600g

affects: ubuntu → linux (Ubuntu)
tags: added: kernel-needs-review kernel-net
picomike (picomike) wrote :

Same here with Intel 3945ABG/BG on maverick. I had no wifi-related issues on previous Ubuntu versions. My average download speed is 40kB/s when it's supposed to be around 600kB/s.

Jeremy Foshee (jeremyfoshee) wrote :

Hi munny,

Please be sure to confirm this issue exists with the latest development release of Ubuntu. ISO CD images are available from http://cdimage.ubuntu.com/daily/current/ . If the issue remains, please run the following command from a Terminal (Applications->Accessories->Terminal). It will automatically gather and attach updated debug information to this report.

apport-collect -p linux 621265

Also, if you could test the latest upstream kernel available that would be great. It will allow additional upstream developers to examine the issue. Refer to https://wiki.ubuntu.com/KernelMainlineBuilds . Once you've tested the upstream kernel, please remove the 'needs-upstream-testing' tag. This can be done by clicking on the yellow pencil icon next to the tag located at the bottom of the bug description and deleting the 'needs-upstream-testing' text. Please let us know your results.

Thanks in advance.

    [This is an automated message. Apologies if it has reached you inappropriately; please just reply to this message indicating so.]

tags: added: needs-kernel-logs
tags: added: needs-upstream-testing
tags: added: kj-triage
Changed in linux (Ubuntu):
status: New → Incomplete
Achim (ach1m) wrote :

I am no more able to reproduce the problem, with ubuntu kernel 2.6.35.20.21.

lspci | grep 3945
0b:00.0 Network controller: Intel Corporation PRO/Wireless 3945ABG [Golan] Network Connection (rev 02)

linux:
  Installed: (none)
  Candidate: 2.6.35.20.21
  Version table:
     2.6.35.20.21 0
        500 http://de.archive.ubuntu.com/ubuntu/ maverick/main i386 Packages

Changed in linux (Ubuntu):
status: Incomplete → Fix Released
picomike (picomike) wrote :

Not fixed for me. It still happens even with 2.6.35.21 kernel.

Changed in linux (Ubuntu):
status: Fix Released → Incomplete

AlsaVersion: Advanced Linux Sound Architecture Driver Version 1.0.23.
Architecture: i386
AudioDevicesInUse:
 USER PID ACCESS COMMAND
 /dev/snd/controlC0: miguel 1470 F.... pulseaudio
CRDA: Error: [Errno 2] No existe el archivo o directorio
Card0.Amixer.info:
 Card hw:0 'Intel'/'HDA Intel at 0xd2400000 irq 46'
   Mixer name : 'Realtek ALC883'
   Components : 'HDA:10ec0883,10250090,00100002 HDA:14f12bfa,1025007f,00090000'
   Controls : 24
   Simple ctrls : 14
DistroRelease: Ubuntu 10.10
HibernationDevice: RESUME=UUID=95560f48-18f5-411d-bd58-603d38e89a62
InstallationMedia: Ubuntu 10.10 "Maverick Meerkat" - Beta i386 (20100901.1)
MachineType: Acer Aspire 5610
NonfreeKernelModules: nvidia
Package: linux (not installed)
PccardctlIdent:
 Socket 0:
   no product info available
PccardctlStatus:
 Socket 0:
   no card
ProcCmdLine: BOOT_IMAGE=/boot/vmlinuz-2.6.35-21-generic root=UUID=4c026b8a-d291-42e5-8b45-d7c28991145b ro quiet splash
ProcEnviron:
 LANG=es_ES.utf8
 SHELL=/bin/bash
ProcVersionSignature: Ubuntu 2.6.35-21.30-generic 2.6.35.4
Regression: Yes
RelatedPackageVersions: linux-firmware 1.38
Reproducible: Yes
RfKill:
 0: phy0: Wireless LAN
  Soft blocked: no
  Hard blocked: no
Tags: maverick kernel-config regression-potential needs-upstream-testing
Uname: Linux 2.6.35-21-generic i686
UserGroups: adm admin cdrom dialout lpadmin plugdev sambashare
dmi.bios.date: 02/13/2007
dmi.bios.vendor: Acer
dmi.bios.version: V3.50
dmi.board.name: Grapevine
dmi.board.vendor: Acer
dmi.board.version: N/A
dmi.chassis.type: 10
dmi.chassis.vendor: Acer
dmi.chassis.version: N/A
dmi.modalias: dmi:bvnAcer:bvrV3.50:bd02/13/2007:svnAcer:pnAspire5610:pvrV3.50:rvnAcer:rnGrapevine:rvrN/A:cvnAcer:ct10:cvrN/A:
dmi.product.name: Aspire 5610
dmi.product.version: V3.50
dmi.sys.vendor: Acer

tags: added: apport-collected

apport information

apport information

apport information

apport information

apport information

apport information

apport information

apport information

apport information

apport information

apport information

apport information

apport information

apport information

apport information

apport information

apport information

apport information

apport information

oliver (sorg.oliver) wrote :
Download full text (3.7 KiB)

this bug also affects me in fresh installed maverick.
network speed over wifi is never faster than 150kb/s. Even when i copy stuff from my local network storage over nfs.

regards oliver

dmesg:
[ 2181.202588] iwl3945 0000:0c:00.0: Detected Intel Wireless WiFi Link 3945ABG
[ 2181.202736] iwl3945 0000:0c:00.0: irq 43 for MSI/MSI-X
[ 2181.203341] phy0: Selected rate control algorithm 'iwl-3945-rs'
[ 2184.755327] ADDRCONF(NETDEV_UP): eth0: link is not ready
[ 2184.785415] iwl3945 0000:0c:00.0: loaded firmware version 15.32.2.9
[ 2184.862250] ADDRCONF(NETDEV_UP): wlan0: link is not ready
[ 2190.598031] wlan0: authenticate with 00:1f:3f:a4:80:c1 (try 1)
[ 2190.603331] wlan0: authenticated
[ 2190.604681] wlan0: associate with 00:1f:3f:a4:80:c1 (try 1)
[ 2190.624421] wlan0: RX AssocResp from 00:1f:3f:a4:80:c1 (capab=0x431 status=0 aid=5)
[ 2190.624429] wlan0: associated
[ 2190.633272] ADDRCONF(NETDEV_CHANGE): wlan0: link becomes ready
[ 2201.440085] wlan0: no IPv6 routers present
[ 2700.721281] b44 ssb0:0: eth0: powering down PHY
[ 2700.956153] wlan0: deauthenticating from 00:1f:3f:a4:80:c1 by local choice (reason=3)
[ 2701.019663] cfg80211: All devices are disconnected, going to restore regulatory settings
[ 2701.019674] cfg80211: Restoring regulatory settings
[ 2701.019681] cfg80211: Calling CRDA to update world regulatory domain
[ 2701.029362] cfg80211: World regulatory domain updated:
[ 2701.029369] (start_freq - end_freq @ bandwidth), (max_antenna_gain, max_eirp)
[ 2701.029377] (2402000 KHz - 2472000 KHz @ 40000 KHz), (300 mBi, 2000 mBm)
[ 2701.029383] (2457000 KHz - 2482000 KHz @ 20000 KHz), (300 mBi, 2000 mBm)
[ 2701.029390] (2474000 KHz - 2494000 KHz @ 20000 KHz), (300 mBi, 2000 mBm)
[ 2701.029396] (5170000 KHz - 5250000 KHz @ 40000 KHz), (300 mBi, 2000 mBm)
[ 2701.029403] (5735000 KHz - 5835000 KHz @ 40000 KHz), (300 mBi, 2000 mBm)
[ 2722.649596] iwl3945 0000:0c:00.0: PCI INT A disabled
[ 2768.237253] ADDRCONF(NETDEV_UP): eth0: link is not ready
[ 2801.445177] cfg80211: Calling CRDA to update world regulatory domain
[ 2801.452802] cfg80211: World regulatory domain updated:
[ 2801.452806] (start_freq - end_freq @ bandwidth), (max_antenna_gain, max_eirp)
[ 2801.452811] (2402000 KHz - 2472000 KHz @ 40000 KHz), (300 mBi, 2000 mBm)
[ 2801.452815] (2457000 KHz - 2482000 KHz @ 20000 KHz), (300 mBi, 2000 mBm)
[ 2801.452819] (2474000 KHz - 2494000 KHz @ 20000 KHz), (300 mBi, 2000 mBm)
[ 2801.452823] (5170000 KHz - 5250000 KHz @ 40000 KHz), (300 mBi, 2000 mBm)
[ 2801.452826] (5735000 KHz - 5835000 KHz @ 40000 KHz), (300 mBi, 2000 mBm)
[ 2801.519779] iwl3945: Intel(R) PRO/Wireless 3945ABG/BG Network Connection driver for Linux, in-tree:s
[ 2801.519785] iwl3945: Copyright(c) 2003-2010 Intel Corporation
[ 2801.519870] iwl3945 0000:0c:00.0: PCI INT A -> GSI 17 (level, low) -> IRQ 17
[ 2801.519892] iwl3945 0000:0c:00.0: setting latency timer to 64
[ 2801.560347] iwl3945 0000:0c:00.0: Tunable channels: 13 802.11bg, 23 802.11a channels
[ 2801.560353] iwl3945 0000:0c:00.0: Detected Intel Wireless WiFi Link 3945ABG
[ 2801.560501] iwl3945 0000:0c:00.0: irq 43 for MSI/MSI-X
[ 2801.561138] phy0: Selected rate contr...

Read more...

themuddler (mike-udall) wrote :

I'm also affected both on an upgraded install from Lucid and when running from a livecd.

ubuntu 2.6.35-22-generic #33-Ubuntu SMP Sun Sep 19 20:34:50 UTC 2010

dmesg extract:
[ 31.872152] iwl3945: Intel(R) PRO/Wireless 3945ABG/BG Network Connection driver for Linux, in-tree:s
[ 31.872156] iwl3945: Copyright(c) 2003-2010 Intel Corporation
[ 31.872272] iwl3945 0000:03:00.0: PCI INT A -> GSI 17 (level, low) -> IRQ 17
[ 31.872287] iwl3945 0000:03:00.0: setting latency timer to 64
[ 31.933068] iwl3945 0000:03:00.0: Tunable channels: 13 802.11bg, 23 802.11a channels
[ 31.933073] iwl3945 0000:03:00.0: Detected Intel Wireless WiFi Link 3945ABG
[ 31.933188] alloc irq_desc for 48 on node -1
[ 31.933191] alloc kstat_irqs on node -1
[ 31.933224] iwl3945 0000:03:00.0: irq 48 for MSI/MSI-X
[ 32.073717] r8169 0000:04:00.0: eth0: link down

papukaija (papukaija) wrote :

This bug has been apport collected and is even confirmed in Maverick.

Changed in linux (Ubuntu):
status: Incomplete → Confirmed
tags: added: maverick
removed: needs-kernel-logs
Changed in linux (Ubuntu Maverick):
status: New → Confirmed
importance: Undecided → High
tags: added: regression-release
Changed in linux (Ubuntu Maverick):
milestone: none → maverick-updates
Nicolas Albert (nicoa380) wrote :

Same issue here, with an Asus notebook. Wifi bandwidth was perfect until Maverick 10.10 ! It's very slow now.

$ dmesg | grep 3945
[ 21.734034] iwl3945: Intel(R) PRO/Wireless 3945ABG/BG Network Connection driver for Linux, in-tree:s
[ 21.734038] iwl3945: Copyright(c) 2003-2010 Intel Corporation
[ 21.734111] iwl3945 0000:03:00.0: PCI INT A -> GSI 17 (level, low) -> IRQ 17
[ 21.734126] iwl3945 0000:03:00.0: setting latency timer to 64
[ 21.788661] iwl3945 0000:03:00.0: Tunable channels: 13 802.11bg, 23 802.11a channels
[ 21.788664] iwl3945 0000:03:00.0: Detected Intel Wireless WiFi Link 3945ABG
[ 21.788816] iwl3945 0000:03:00.0: irq 45 for MSI/MSI-X
[ 21.797260] phy0: Selected rate control algorithm 'iwl-3945-rs'
[ 27.296988] iwl3945 0000:03:00.0: loaded firmware version 15.32.2.9

There is any workaround ?

Donny Kurnia (donnykurnia) wrote :

I want to upgrade Lucid in my laptop into Maverick, but this bug stopped me, since I need internet connection via Wi-fi in the laptop. Please fix this bug asap so the unfortunate laptop owner with 3945ABG wireless chip can use Maverick Meerkat.

Thanks

denfio (denfio) wrote :

any idea when the bug may be addressed, this is painfully slow.

Donny Kurnia (donnykurnia) wrote :

One question for those who have Maverick installed in laptop with 3945ABG wifi chip, if you boot the laptop using lucid kernel, is the speed back to normal or stay the same? If the bug is in the kernel, then I will not mind keeping the old kernel until the new kernel resolve this bug.

psychok7 (nunok7) wrote :

I had no problems on lucid.. upgraded to maverick and my wireless is extremely slow.. also using iwl3945 ..i should add that i tried installing linux-backports-modules-wireless-maverick-generic but had no luck...
what should i do?? should i leave it installed? it there a fix coming out?? will a clean install fix this?

Donny Kurnia (donnykurnia) wrote :

@psychok7 and other that have maverick installed, can you try to install lucid kernel and lucid wireless driver:

linux-backports-modules-compat-wireless-2.6.34-2.6.32-25-generic
linux-backports-modules-wireless-lucid-generic
linux-image-2.6.32-25-generic
linux-headers-2.6.32-25
linux-headers-2.6.32-25-generic

Those are the kernel and wireless module that installed in my lucid right now. Try to install it and report back if the wireless speed is back just like when using lucid.

Many thanks.

janinko (ja-brazdil) wrote :

Same problem like others.

If I try boot with linux-headers-2.6.32-25 kernel I still have slow wifi.

janinko (ja-brazdil) wrote :

When I installed
linux-backports-modules-compat-wireless-2.6.34-2.6.32-25-generic
linux-backports-modules-wireless-lucid-generic

and reboot again with linux-2.6.32-25-generic kernel, still have slow wifi :(

uname -a:

Linux janinko-laptop 2.6.32-25-generic #45-Ubuntu SMP Sat Oct 16 19:48:22 UTC 2010 i686 GNU/Linux

dpkg -l :

ii linux-backports-modules-compat-wireless-2.6.34-2.6.32-25-generic 2.6.32-25.24
ii linux-backports-modules-wireless-lucid-generic 2.6.32.25.27
ii linux-headers-2.6.35-22 2.6.35-22.35
ii linux-headers-2.6.35-22-generic 2.6.35-22.35
ii linux-headers-generic 2.6.35.22.23
rc linux-image-2.6.32-21-generic 2.6.32-21.32
rc linux-image-2.6.32-22-generic 2.6.32-22.36
rc linux-image-2.6.32-23-generic 2.6.32-23.37
rc linux-image-2.6.32-24-generic 2.6.32-24.43
ii linux-image-2.6.32-25-generic 2.6.32-25.45
ii linux-image-2.6.35-22-generic 2.6.35-22.35
ii linux-image-generic 2.6.35.22.23

Félix (felix-rauch) wrote :

Maybe downgrading linux-firmware package would help?

Donny Kurnia (donnykurnia) wrote :

In lucid, here is the version of linux-firmware package:

$ dpkg -l|grep linux-firmware
ii linux-firmware 1.34.1 Firmware for Linux kernel drivers

I have the same problem here, but it works with old kernel.
At speedtest.net I got:
0.37 Mbps with default kernel 2.6.35-22
9.18 Mbps when booting with kernel 2.6.32-25 (this is the same I get with wired connection)

Nick B. (futurepilot) wrote :

This problem showed up for me in Maverick. Lucid and previous releases worked fine. I tested the backported Maverick kernel on Lucid (the linux-lts-backport-maverick package) and I was able to reproduce the wireless slow down on Lucid.

Donny Kurnia (donnykurnia) wrote :

@Nick, so the culprit is the linux-lts-backport-maverick then? @Fabio, when you are using kernel 2.6.32-25, what the firmware packages that installed in your laptop?

Jawad Rashid (nokia-2003) wrote :

I have a intel PRO/wireless 3945ag wireless card as well and i am having the same problem. When i connect through the wired ethernet connection my speeds are okay but when connecting using wireless network i get slow speeds and sometimes page fails to load due to this slow speed.

The linux-lts-backport-maverick package is the same kernel from
Maverick. I'm just confirming that it appears to be a kernel bug which
appeared somewhere after 2.6.32. (oddly there are bug reports of this
problem that were submitted long ago about this, not sure why I'm just
seeing it now) I also tested the upstream 2.6.36 kernel and it has the
same problem.

On 10/23/2010 04:02 AM, Donny Kurnia wrote:
> @Nick, so the culprit is the linux-lts-backport-maverick then? @Fabio,
> when you are using kernel 2.6.32-25, what the firmware packages that
> installed in your laptop?
>
>

Nicolas Albert (nicoa380) wrote :

I booted using the 2.6.32-25-generic kernel (from lucid, not deleted after upgrade to maverick) and the bandwidth is good.

Bandwidth between my laptop (iwl3945) and my ADSL Box (Freebox)
kernel 2.6.35 > 1 Mb
kernel 2.6.32 > 12 Mb

It's not a very good workaround, but I'll live with that for the moment. So I configured my /etc/default/grub with
GRUB_DEFAULT=saved and run sudo update grub for use the 2.6.32 by default after the first selection.

Donny Kurnia (donnykurnia) wrote :

Thanks for the sharing @Nicolas. I might do the same for my laptop after I got some free time to upgrade the Lucid to Maverick.

ehrms (ehrms) wrote :

Same problem like others.

janinko (ja-brazdil) wrote :

janinko wrote on 2010-10-22: #34
> Same problem like others.
> If I try boot with linux-headers-2.6.32-25 kernel I still have slow wifi.

I tried it again and it worked fine. I think the problem in previous report was caused by router.

So, It's like Nicolas Albert said.

psychok7 (nunok7) wrote :

should i leave my linux-backports-modules-wireless-maverick-generic enabled or i should disable it and wait for a ubuntu update? when will the update be by the way?

sergeos (sergeos) wrote :

same problem here. using 64 bit Ubuntu 10.10 on a Fujitsu Lifebook notebook, the transfer rate doesn't go over 100 KB/sec, in windows it's normally over 1Mb.

is downgrading to lucid the only work around to this problem?

delijati (delijati) wrote :

On mac it is the default power managment. Turning it off fixes the problem.

https://help.ubuntu.com/community/MacBookPro7-1/Maverick#Wireless

Thanks to the one who discoverd this.

krader (apictor) wrote :

I have the same problem, and now I'm using Maverick but with lucid kernel. I've tried what has commented delijati about power manager, but I'm not able to change it. Althow, I've seen it is disabled, so it is not the solution for my case (Acer laptop)

frode (falelaster) wrote :

has anyone tried using another driver, well first time I installed ubuntu on my lenovo 3 years ago I had to install a driver and it worked nice, I updated all the way to maveric, and I got this problem, maby the driver got changed in the process. Yeasterday I installed lusid from scrach, and it did`nt help. Maby it works whit a windows driver, has anyone tried. Pleace bare whit me I`m just a user.

Rechner-Tester (cs-rechner) wrote :

I have a ThinkPad T60 here for installation, it has a 3945ABG and a Mobile Radeon X1300.
Just checked the maverick release notes because the lucid kernel doesn't support the Radeon power-management (at least not very well)
So I can choose between low network speed or high power consumption. Since this not my notebook maybe it would be better to go with the pre-installed windows than giving some one a bad impression of linux/ubuntu. Seems like a show stopper for me. :-(

Donny Kurnia (donnykurnia) wrote :

@Rechner, I'm using Lucid in my Thinkpad R61 with wlan Power Management set to off. I still had almost 4 hour time with 9cell compatible battery (the original battery had died a year ago). I haven't had time to install Maverick in this laptop yet. But if the slowness is caused by power management, then turning it off will not affected the battery life too much. FYI, while in battery, I use normal CPU speed (on demand), normal backlight level, so I can still working comfortable using battery.

Rechner-Tester (cs-rechner) wrote :

Donny: Thank you for sharing your experience with me, but you got me wrong:
lucid (Kernel 2.6.32) doesn't support the *powermanagment for Radeon GPUs* very well (if you're using KMS).
My own T60 with Mobile Radeon X1400 takes about 18 watts with an installed lucid but only 12 watts with maverick rc live or this well known "other OS" ;-), (all with lowest brightness to be comparable)
With maverick on the other hand I'll have my 12 watts but slow WiFi.

Greetings

Donny Kurnia (donnykurnia) wrote :

@Rechner, this bug report is about the slowness of WiFi in laptop that use 3945ABG. @delijati above write that the slowness might be because of power management. In lucid that I'm using right now, I had the power management turned off. I haven't had a time to install maverick yet. If the slowness of Wifi is because of the power management setting, then I want to tell you that setting it to off will not affect the battery runtime too big.

My Thinkpad R61 is using Intel VGA, not Radeon. The average power consumption is around 18 - 21 W (based on gnome-power-management power statistic history graph). So I have no comment about Radeon performance, beside it is out of this bug report scope.

So, anyone else that have installed Maverick and turned off Power Management setting in wlan0 device? Is the slow problems gone or it is still as slow as before?

ehrms (ehrms) wrote :

Maverick installed and Power Management setting in wlan0 turned off. The problem still exists. I made some checks and found that the connection is supported by dial-up with about 54 Mbps. After some time the rate goes back to 1 Mbps. Turn power management off is not the solution for me. Hardware: Dell Inspirion and 3945ABG.

kdekda (teabof) wrote :

Same problem here with Maverick on a Dell Inspiron 1520, max speed 1Mbs. Maybe this wifi card can go faster with ndiswrapper?

krader (apictor) wrote :

It happens also with kernel 2.6.36 available in kernel-ppa mainline. For me, only solution is using kernel 2.6.32 from lucid

fix for this problem was committed three days ago in iwlwifi git repository, see
http://git.kernel.org/?p=linux/kernel/git/iwlwifi/iwlwifi-2.6.git;a=commit;h=0d8e0e28a27779f480adb6674ca5fc29879a2080
tested it on an Thinkpad T60 and wifi speed seem's to be back to normal.
now waiting for ubuntu to release an update with the fixed iwl3945 module ..

Nicolas Albert (nicoa380) wrote :

I think I find a workaround for 2.6.35 kernel.

Just do a :

sudo iwpriv wlan0 set_power 7

and my wireless test speed reach ~6.5 Mb/s instead of ~1 Mb/s.

You can slow down again with "sudo iwpriv wlan0 set_power 1".

Someone can confirm ?

kdekda (teabof) wrote :

thank you Nicolas!!
Now my wireless test speed reach ~4.5 Mb/s instead of ~1 Mb/s.

However, i'll wait the solution proposed by Giuliano in #60

kdekda (teabof) wrote :

after a restart the speed is about 1Mb/s. Typing "sudo iwpriv wlan0 set_power 7" doesn't work anymore.

Ryan Malander (rybo213) wrote :

So how long is it usually before an update like this is made available by Ubuntu?

Rechner-Tester (cs-rechner) wrote :

I installed maverick on the above mentioned T60. Networkmanager shows me between 6-54 Mbit/s (and it recovers back to 48-54 Mbit/s even if it showed 6Mbit/s before). Download speeds with synaptic are at ~2500kbyte/s, as expected.
Maybe it's because I'm ruining my AP with 802.11a/g (5Ghz) only? Encryption is set to WPA2-Personal/AES only too.

Eric Appleman (erappleman) wrote :

I can confirm Giuliano's findings.

The commit he listed (and the subsequent commits immediately after) has solved the issue.

If you splice the iwlwifi folder from the latest snapshot of that git tree with the iwlwifi folder from compat-wireless, you can save yourself the hours-long kernel compilation and build a full-speed iwl3945 module.

Eric Appleman (erappleman) wrote :

Grrrr.

The speed doesn't last.

Progress is progress, I guess.

Eric Appleman (erappleman) wrote :

I had it before...

Why won't it work it anymore?

Was it the new git drivers, disabling CONFIG_CFG80211_DEFAULT_PS, or both?

Eric Appleman (erappleman) wrote :

Giuliano, can you post a step-by-step guide, please?

This is going to bother me until I figure it out.

By the way, can everyone who is reporting increased speeds please temporarily blacklist the iwl3945 module and try again with ndiswrapper plus the netw5x32 (version 12.2.0.11) driver?

http://www.mediafire.com/?rc5jbicm6is85h8

iwl3945: Max download is 5 Mbps
ndiswrapper: Max download is 22 Mbps

Nick B. (futurepilot) wrote :

That commit is not working for me either. I downloaded the snapshot of the commit and merged the iwlwifi directory into the latest compat-wireless daily snapshot, compiled, installed, and rebooted but wireless is still only reaching around 1.5mbps. Maybe this isn't the correct way to do this? I also tried "sudo iwpriv wlan0 set_power 7" but it just returned "wlan0 no private ioctls."

Nicolas Albert (nicoa380) wrote :

<< I also tried "sudo iwpriv wlan0 set_power 7" but it just returned "wlan0 no private ioctls." >>

It was a normal ouput and it still works for me and survive after halt or reboot.

Eric Appleman (erappleman) wrote :

The iwpriv command doesn't work for me.

Nick B. (futurepilot) wrote :

Oh, OK. But it didn't change anything for me.

On 11/04/2010 02:48 PM, Nicolas Albert wrote:
> << I also tried "sudo iwpriv wlan0 set_power 7" but it just returned
> "wlan0 no private ioctls." >>
>
> It was a normal ouput and it still works for me and survive after halt
> or reboot.
>
>

Thomas Costick (3dbloke) wrote :

I thought it worth noting that I do *not* have the problem, although my WiFi card is the one affected.
Ubuntu 10.10, kernel 2.6.35-22-generic.
Dell Inspiron 6400, 2GHz Centrino Duo, 2GB memory.

$ dmesg | grep 3945
[ 0.394592] PNP: PS/2 Controller [PNP0303:KBC,PNP0f13:PS2M] at 0x60,0x64 irq 1,12
[ 6.168072] iwl3945: Intel(R) PRO/Wireless 3945ABG/BG Network Connection driver for Linux, in-tree:s
[ 6.168077] iwl3945: Copyright(c) 2003-2010 Intel Corporation
[ 6.168164] iwl3945 0000:0b:00.0: PCI INT A -> GSI 16 (level, low) -> IRQ 16
[ 6.168180] iwl3945 0000:0b:00.0: setting latency timer to 64
[ 6.222683] iwl3945 0000:0b:00.0: Tunable channels: 13 802.11bg, 23 802.11a channels
[ 6.222686] iwl3945 0000:0b:00.0: Detected Intel Wireless WiFi Link 3945ABG
[ 6.222858] iwl3945 0000:0b:00.0: irq 44 for MSI/MSI-X
[ 6.392115] phy0: Selected rate control algorithm 'iwl-3945-rs'
[ 10.967349] iwl3945 0000:0b:00.0: loaded firmware version 15.32.2.9

Speedtest.net to London (I am in Sussex, UK) returns a healthy 10.95Mb/s download, 0.79Mb/s upload.

sergeos (sergeos) wrote :

It seems that Rechner-Tester has pointed in the right direction, I have set up my wifi router to work in G only mode and it seems to have fixed the issue (fingers crossed), getting adequate transfer speeds now.

Thomas Costick (3dbloke) wrote :

For the record, with the good performance mentioned above:
My WiFi router, a D-Link "DSL 2640-R", is configured for "mixed 802.11g and b".
The wireless security is "Auto (WPA or WPA2)".

Nick B. (futurepilot) wrote :

My router has always been in G-only mode. Makes no difference here.

On 11/06/2010 05:27 PM, sergeos wrote:
> It seems that Rechner-Tester has pointed in the right direction, I have
> set up my wifi router to work in G only mode and it seems to have fixed
> the issue (fingers crossed), getting adequate transfer speeds now.
>
>

sergeos (sergeos) wrote :

it's probably just a coincidence then, I just realized that I've had a couple of virtual boxes running in the background for the past couple of days, maybe vmware workstation is not letting power management to kick in on the wlan interface hence the transfer rates have been quite good. just a theory...

Eric Appleman (erappleman) wrote :

What the hell?

I'm getting 22 Mbps with iwl3945 tonight and I didn't do anything...

Eric Appleman (erappleman) wrote :

Ah. I was playing around with my CPU frequency scaler using the applet.

Rechner-Tester (cs-rechner) wrote :

What a mistake: "802.11a/g" in my last posting is wrong, it's "802.11a/n" . (802.11g is not 5GHz but 2,4GHz)
Sorry

I made additional test on my T60 using the patched iwlwifi from the git repository, i wrote in my earlier comment that the speed was back to normal, but that doesn't last longer or work in a reliable ways, every now and then the speed will go from normal to around 1mbps without apparent reason, i had it working for hours without problem than drop back to 1mbps, sometimes reloading the iwl3945 module help, sometimes not.
Anyway i can't make other test, i swapped my T60 for a T400 with 5100 agn so now i'm facing other problem (802.11N disabled in latest iwlagn module ..) but at least i can use full 11g speed.

SOLVED for my INTEL 4965...

Speed bug seems solved with kernel 2.6.37...
http://kernel.ubuntu.com/~kernel-ppa/mainline/v2.6.37-rc1-maverick/

Just upgraded and for now my speed is normal.

Rechner-Tester (cs-rechner) wrote :

Thank you for your feedback Luca, but I'm quite sure this bug here never affected you. This bug is about:
     "Slow Wireless Connection in Intel 3945abg"
but you wrote:"SOLVED for my INTEL 4965..."

Maybe your was affected by an other bug?

picomike (picomike) wrote :

That new 2.6.37 kernel contains some iwl3945 fixes. Maybe it solves this bug. Somebody could upgrade and confirm this for the intel 3945 wifi chipset?

Paueti (paugonzaleza) wrote :

Doesn't work for me and kernel 2.6.37 crashes sometimes

Paueti (paugonzaleza) wrote :

Doesn't work for me and kernel 2.6.37 isn't for production. Crashes sometimes

Eric Appleman (erappleman) wrote :

New kernel doesn't fix the issue.

Linux kingfisher 2.6.37-4-generic #12-Ubuntu SMP Mon Nov 15 21:26:16 UTC 2010 i686 GNU/Linux

Jimmy Merrild Krag (beruic) wrote :

I think I have this issue too.

Used to transfer files with almost 2 Mb/s, but now I get only 100 kb/s.

Also on a cable LAN connection the speed is down from 5 Mb/s to 3 Mb/s

All is measured with SSH transfer where my computer is connected to the same router as the server with either WLAN or LAN.

Jimmy Merrild Krag (beruic) wrote :

Think I had an overhead problem, or something else. Problem seems gone now.

Espen (espenbe) wrote :

I have a DELL Latitude D820 with the same problem. Yesterday I upgraded from 9.10 to 10.10 (changed hard disc and did a fresh 10.10 install). I get the following transfer:
  Down: 1.35Mbit/s
  Up: 5.02Mbit/s

My wife has a MacBookPro and we're connected to the same WLAN. Her corresponding numbers:
  Down: 13.92Mbit/s
  Up: 5.02Mbit/s

Kernel: Linux ministerial 2.6.35-22-generic #35-Ubuntu SMP Sat Oct 16 20:36:48 UTC 2010 i686 GNU/Linux

Pat Dunbeck (pdunbeck) wrote :

i can't wait for somebody smarter than me to figure this one out :(

alexcastanaza (dacastanaza) wrote :

I have not tried Maverick release, I'm using Lucid, but I have the affected wireless card, so that is enough reason to not upgrade, until the issue is fixed. Intel cards should be well supported, please fix this bug.

Raju (raju) wrote :

I too will be eagerly waiting for this bug to be fixed so I can upgrade to 10.10!

Laszlo Suto (laszlo-suto) wrote :

It's really really annoying this bug still exists. I'd have to connect my laptop always to wired network. Could we do anything to help the fix of this bug?

frode (falelaster) wrote :

It`s the router that makes this bug tick, it seems to slow down on one of the routers I have used lately, the problem is the same both on 10.04 and 10.10.

Pat Dunbeck (pdunbeck) wrote :

I have had this problem for awhile. I saw that it was a confirmed bug so I ignored it and waited for a fix. After waiting too long I started searching and came up with an interesting result.

With my HP dv2000 that uses an intel 3945 the bug first showed up with an upgrade from 10.04 to 10.10. I tried to use wireless but found it incredibly slow and unable to connect to the router well. After playing with it for awhile I found that the wireless switch on the front of the computer no longer let me control the status of the wireless card and the card was being held in an off state. Recently I found a forum post (link below) that helped me make a step in the right direction. Running ....

sudo rfkill unblock all
Source: http://start.ubuntuforums.org/showthread.php?p=10047869

Running that code in terminal gave me back control of the wireless disable switch allowing me to turn the card back on. I then went and ran a speed test and found that performance was as expected.

[URL=http://www.speedtest.net][IMG]http://www.speedtest.net/result/1066008894.png[/IMG][/URL]

I hope that this helps others that have been running into this problem. If somebody trying to troubleshoot this bug needs more info let me know how I can help.

kdekda (teabof) wrote :

#more /var/lib/NetworkManager/NetworkManager.state
return me:
[main]
NetworkingEnabled=true
WirelessEnabled=true
WWANEnabled=true

The wireless switch has no problem on my dell inspiron 1520. "sudo rfkill unblock all" so had no effect for me.

Chad A. Davis (chadadavis) wrote :

I just did a fresh install of 10.10 on a Dell Inspiron E1705, which
has the 3945ABG (rev 02) wifi card and my wifi speed is not reduced
(relative to what it was on 10.04).
I'm using the i686 kernel 2.6.35-23-generic #41-Ubuntu which is the
current one from the Update Manager.
Has someone considered if this bug only occurs on upgrades from 10.04,
rather than fresh installs of 10.10?
I also hesitated to upgrade, but the issue is not affecting me. If
you're in the same situation, I would try the live CD and see if the
issue will indeed affect you.

On Sat, Dec 11, 2010 at 10:29, kdekda <email address hidden> wrote:
> #more /var/lib/NetworkManager/NetworkManager.state
> return me:
> [main]
> NetworkingEnabled=true
> WirelessEnabled=true
> WWANEnabled=true
>
> The wireless switch has no problem on my dell inspiron 1520. "sudo
> rfkill unblock all" so had no effect for me.
>
> --
> You received this bug notification because you are a direct subscriber
> of the bug.
> https://bugs.launchpad.net/bugs/621265
>
> Title:
>  Slow Wireless Connection in Intel 3945abg
>
> Status in “linux” package in Ubuntu:
>  Confirmed
> Status in “linux” source package in Maverick:
>  Confirmed
>
> Bug description:
>  With latest daily-live Maverick (2010-08-20), my wireless connection with Intel 3945abg never go over 3mbps speed.
> I try this in local lan and in internet.
> It seems like a regression about iwl3945 driver, i had a similar problem with older kernel where wireless speed was limited to 1mbps, with k/ubuntu 10.04 and 2.6.32 kernel this problem was disappear.
>
> Some information:
> lsb_release -rd:
> Description:    Ubuntu maverick (development branch)
> Release:        10.10
>
> uname -a:
> Linux ubuntu 2.6.35-16-generic #22-Ubuntu SMP Tue Aug 17 02:21:03 UTC 2010 x86_64 GNU/Linux
>
> dmesg | grep 3945:
>
> [   27.977578] iwl3945: Intel(R) PRO/Wireless 3945ABG/BG Network Connection driver for Linux, in-tree:s
> [   27.977583] iwl3945: Copyright(c) 2003-2010 Intel Corporation
> [   27.977678] iwl3945 0000:02:00.0: PCI INT A -> GSI 17 (level, low) -> IRQ 17
> [   27.977693] iwl3945 0000:02:00.0: setting latency timer to 64
> [   28.043199] iwl3945 0000:02:00.0: Tunable channels: 13 802.11bg, 23 802.11a channels
> [   28.043205] iwl3945 0000:02:00.0: Detected Intel Wireless WiFi Link 3945ABG
> [   28.043366] iwl3945 0000:02:00.0: irq 43 for MSI/MSI-X
> [   28.185681] phy0: Selected rate control algorithm 'iwl-3945-rs'
> [   28.523764] iwl3945 0000:02:00.0: loaded firmware version 15.32.2.9
>
> iwconfig:
> wlan0     IEEE 802.11abg  ESSID:"Dorema"
>          Mode:Managed  Frequency:2.472 GHz  Access Point: 00:1A:92:11:1C:C7
>          Bit Rate=54 Mb/s   Tx-Power=15 dBm
>          Retry  long limit:7   RTS thr:off   Fragment thr:off
>          Power Management:off
>          Link Quality=68/70  Signal level=-42 dBm
>          Rx invalid nwid:0  Rx invalid crypt:0  Rx invalid frag:0
>          Tx excessive retries:0  Invalid misc:0   Missed beacon:0
>
> My access point is Asus WL-600g
>
> To unsubscribe from this bug, go to:
> https://bugs.launchpad.net/ubuntu/+source/linux/+bug/621265/+subscribe
>

Eric Appleman (erappleman) wrote :

Both fresh installs and upgrades from at least Karmic and onward are affected.

A similar issue existed around the same time, but that was mitigated with G-only on routers.

This is a different issues involving the driver's rate control algorithm.

Nick B. (futurepilot) wrote :

It does indeed seem to be a rate control issue. When it slows down and I check the router it shows it's only going at 5.5Mbps. If I disconnect and check the router's rate from another wireless computer it immediately jumps back to 36+Mbps which is what it is normally at. It appears when the laptop with the 3945 card is on the wireless it slows the wireless down for everyone else on the wireless too.

On 12/11/2010 06:24 PM, Eric Appleman wrote:
> Both fresh installs and upgrades from at least Karmic and onward are
> affected.
>
> A similar issue existed around the same time, but that was mitigated
> with G-only on routers.
>
> This is a different issues involving the driver's rate control
> algorithm.
>

Jonathan Kulp (jonlancekulp) wrote :

I've been doing some tests since I realized I was suffering from this bug. My internet speed is supposed by be 30 Mbps. I always get about 28.5-29.0 Mbps with a wired ethernet connection, no matter what machine or kernel or OS. Wireless differs. On Linux I get better performance with the older kernel, like everyone else:

kernel 2.6.35-22: 2.1 Mbps max down, about 3 Mbps up
kernel 2.6.32-25: 12.0 Mbps max down and up

It's better with the old kernel, but it's still pretty bad compared with when I boot into Windows:

Vista SP2: 20.0 Mbps max up and down

It's hard to believe Vista could out-perform linux at anything, but this is ridiculous. Even when performing at its best, the iwlwifi driver is crappy compared to what I get on Windows. :(

Paul (furia) wrote :

I had the same issue on Ubuntu 10.10 and Mint 10, with PAE/non-PAE kernels, both WUBI/clean installs. The download speed was ~20 times slower than on Windows/previous releases of Ubuntu.

I solved the problem following Eric's suggestion above, by installing the Windows driver (see the mediafire link) - I didn't even bother to blacklist the corresponding kernel module. After reboot, the download speed increased to normal values.

So the issue should be somewhere in the drivers/kernel module. I wanted to clear this out, since I've seen the problem reported on many forums, and the solutions suggested there were strange-to-ridiculous, involving a lot of router related config, disabling DHCP, disabling IPV6, blaming WUBI install, etc.

cocolocotero (jalvarezrom) wrote :

A posible solution:
I was the same problem with ubuntu 10.10

I marked the pre-release updates and the unsupported updates in the update manager.
This get the kernel 2.6.35-24-generic and install it. With a slow connection this would be hours to install it!!!

After the update the connection works normally for me.

Eric Appleman (erappleman) wrote :

This problem still exists upstream and affects Natty (11.04).

I don't see anything in the release notes of that kernel reflecting a fix for this, but I'll give it a try.

Nick B. (futurepilot) wrote :

Tested 2.6.35-24. Didn't fix it for me.

On 12/13/2010 02:11 PM, cocolocotero wrote:
> A posible solution:
> I was the same problem with ubuntu 10.10
>
>
> I marked the pre-release updates and the unsupported updates in the update manager.
> This get the kernel 2.6.35-24-generic and install it. With a slow connection this would be hours to install it!!!
>
> After the update the connection works normally for me.
>

michael (michaelmateu) wrote :

After testing Intel 3945 on Ubuntu 10.10 & Ubuntu 11.04, I can confirm the issue still exists with WPA2 Routers.

I finally only got it working on Guadalinex V.7, a very nice ubuntu based distro.

Info:

lsb_release -rd
Description: Guadalinex V7
Release: 10.04

uname -a
Linux miguel-laptop 2.6.32-25-generic #45-Ubuntu SMP Sat Oct 16 19:48:22 UTC 2010 i686 GNU/Linux

dmesg | grep 3945
[ 0.283945] alloc kstat_irqs on node -1
[ 13.679017] iwl3945: Intel(R) PRO/Wireless 3945ABG/BG Network Connection driver for Linux, 1.2.26ks
[ 13.679020] iwl3945: Copyright(c) 2003-2009 Intel Corporation
[ 13.679090] iwl3945 0000:03:00.0: PCI INT A -> GSI 17 (level, low) -> IRQ 17
[ 13.679104] iwl3945 0000:03:00.0: setting latency timer to 64
[ 13.744577] iwl3945 0000:03:00.0: Tunable channels: 13 802.11bg, 23 802.11a channels
[ 13.744581] iwl3945 0000:03:00.0: Detected Intel Wireless WiFi Link 3945ABG
[ 13.744718] iwl3945 0000:03:00.0: irq 32 for MSI/MSI-X
[ 14.365564] phy0: Selected rate control algorithm 'iwl-3945-rs'
[ 18.731716] iwl3945 0000:03:00.0: firmware: requesting iwlwifi-3945-2.ucode
[ 18.941682] iwl3945 0000:03:00.0: loaded firmware version 15.32.2.9
[ 40.565706] iwl3945 0000:03:00.0: Microcode SW error detected. Restarting 0x82000008.
[ 40.565728] iwl3945 0000:03:00.0: Error Reply type 0x00000000 cmd REPLY_TX (0x1C) seq 0x0000 ser 0x00000000

What also helps:

Put Router in 54G only mode.
Set Beacon interval to 10ms.
Set DTIM interval to 10ms/5ms.

picomike (picomike) wrote :

Guadalinex V7 is an Ubuntu 10.04 based distro. This bug is not present in
Ubuntu 10.04 and the 2.6.32 kernel, so that's why you got WiFi working
correctly in this case. If I misunderstood you, please let me know. I'm very
interested in this bug to be fixed.

Eric Appleman (erappleman) wrote :

michael, do you router setting recs work with newer kernels?

Pete Boyd (petes-accounts) wrote :

I've been following this bug since the release of Ubuntu 10.10 with utter exasperation, totally dismayed that it's not even been assigned to someone months after release, frustrated at not being able to upgrade my personal laptop because it has "Intel Corporation PRO/Wireless 3945ABG [Golan] Network Connection (rev 02)" on a ThinkPad X60 (though I've upgraded desktop machines).

But then today I thought I'd try what someone suggested of running a live version to see if the bug actually affected me, and it didn't.
So I upgraded the laptop's OS, from 10.04 to 10.10 and everything's fine, an Internet speedtest reports 5.5Mb/s.

Torsten Krah (tkrah) wrote :

I can confirm this is still happening with up-to-date maverick.
Got a Latitude D830 and wireless is more than "slow" - i can not get more than 100Kb/sec where an ath9k asus netbook at the same time does get more than 5Mb/sec.

Eric Appleman (erappleman) wrote :

3 Mb/s max on iwl3945. 24 Mb/s max on ndiswrapper. My ISP rated speed is 30 Mb/s.

I don't like saying it this way, but the higher your ISP speed, the greater your stake is in this bug.

Mtt.Castelli (mtt.castelli) wrote :

I think this is quite unacceptable. I can't see which bug could be higher rated: we just can't browse nor update package, in practice.

We all made a lot of discuss and noise about proprietary driver before since 2005, they said us to buy open product such as Intel are (here
http://www.ubuntu-it.org/contenuti/interviste/ben-collins.shtml
Ubuntu kernel maintainer Ben Collins said 'buy Intel card!'), and now, 2010, wireless do not work for a DRIVER-OPEN-hardware.

Two months are passed since maverick release, and notice this bug was submitted _before_: it is still unsolved.

Dell XPS M1330 Core 2 Duo T7250, Intel Corporation PRO/Wireless 3945abg
Ubuntu 10.10 amd64 clean install.

I'm experiencing the same issue, I've been testing it by copying files from a server in my house using FTP. Transfer rates average 200KB/s or so with the Maverick kernels, however if I use the 2.6.32-21 Lucid kernel I get speeds of 3MB/s!

Here's how I installed the Lucid kernel...

Add these lines to /etc/apt/sources.list:
deb http://us.archive.ubuntu.com/ubuntu/ lucid main restricted
deb-src http://us.archive.ubuntu.com/ubuntu/ lucid main restricted

sudo apt-get update
sudo apt-get install linux-image-2.6.32-21-generic

This installs the image, but since it's an older image, grub doesn't boot to it. You have a few options here. You can try to press ESC on boot to get into the grub menu then manually select the 2.6.32-21 image. I have a hard time with the timing and miss it often. To increase the timeout edit /etc/default/grub and increase the GRUB_HIDDEN_TIMEOUT to something like 5. That gives you more time to press escape.

To make it boot 2.6.32-21 by default, get into the grub menu by pressing ESC right before Ubuntu boots. Count the grub menu entries to the kernel you want, mine was entry 6. Edit /etc/default/grub and change GRUB_DEFAULT=0 to that number. Now your system will boot that kernel automatically.

It works great for me, I know some would rather have a fix for the 2.6.35 kernel, but I don't know of any improvements in 2.6.35 that I need!

Thanks,
Chris

Eric Appleman (erappleman) wrote :

Newer Lucid kernels like 2.6.32-27 don't work?

Eric Appleman (erappleman) wrote :

Hmm. The 32-21 kernel is an improvement.

Still slower than ndiswrapper.

32-21 with iwl3945: 15 Mb/s
32-21 with ndiswrapper: 22 Mb/s

I'm going to try bisecting until I find a kernel that brings the speed down the unacceptable levels that this bug speaks of.

Eric,

Thanks for the reply, I didn't realize there were newer kernels since I don't have a Lucid system right now. I just tested 2.5.32-27 and it works!

The sources.list lines would be:

deb http://us.archive.ubuntu.com/ubuntu/ lucid-updates main restricted
deb-src http://us.archive.ubuntu.com/ubuntu/ lucid-updates main restricted

then:

sudo apt-get update
sudo apt-get install linux-image-2.6.32-27-generic
sudo apt-get install linux-headers-2.6.32-27 (if you need to do any compiling)

One note on grub that I forgot above... When counting the grub menu entries to set the default kernel you have to start counting at 0, not 1, to get the numbers right.

Thanks,
Chris

Eric Appleman (erappleman) wrote :

Wow. Even with a Karmic live session, wireless iwl3945 speed won't break 16 Mbps when right next to the router.

Compare that with 36 Mbps over ethernet through that very same router.

I can't help but wonder if the transition from ipw3945 is the fundamental cause. I'll keep heading backwards.

Eric Appleman (erappleman) wrote :

Gutsy Live USB (ipw3945): 24 Mbps

With this, I'm pretty much convinced that my 3945ABG can't go any faster, something I suspected when my speeds weren't any better on Windows 7.

Furthermore, from what I've seen with Karmic, it also clear to me that iwl3945 has been underperforming for a very long time.

At any rate, I still need to try Hardy, Intrepid, and Jaunty.

Daniel Thomas (drt24) wrote :

Eric: comparisons between ethernet and wireless on the same router might display intrinsic slowness of wifi in comparison with ethernet when using the different combinations of hardware involved.

Far more interesting is how different kernel versions and drivers affects wireless speed. It seems odd that the native driver is so much slower than the ndiswrapper clearly there are some speed problems with that driver that have only got worse in recent versions...

Good luck in finding exactly where the bug was added. Hopefully this bug will get fixed before Natty or I may be stuck on Lucid for a long time.

tags: added: natty
Eric Appleman (erappleman) wrote :

Max speeds over time using Live USB sessions

Gutsy (ipw3945): 24 Mbps
Karmic (iwl3945): 16 Mbps
Lucid (iwl3945): 16 Mbps
Maverick (iwl3945): 1-3 Mbps
Natty (iwl3945): 1-3 Mbps
Natty (ndiswrapper): 24 Mbps

Jonathan Kulp (jonlancekulp) wrote :

This problem prompted me to order a new wireless card, Intel 5100. Only cost about $10 on eBay so I figured it was worth a try. I'll be curious to see if it helps or whether the Intel driver bug applies to other cards as well.

Eric: I tried to install ndiswrapper recently and couldn't get it working. Hosed my whole wireless setup in fact, had to restore system from cloned image. Do you know of a step-by-step to do it? I couldn't find one. :(

Eric Appleman (erappleman) wrote :
Eric Appleman (erappleman) wrote :

btw, also make sure to rmmod or modprobe -r the iwl3945 driver.

Mtt.Castelli (mtt.castelli) wrote :

  Eric Appleman wrote:
  "...
  Maverick (iwl3945): 1-3 Mbps
  ..."

Eric, I could live also with 1 or 2 Mbs (in Italy you shouldn't really aspect much more from your ISP...). By just 1Mbps I could browse and download updates or use p2p, but... But I'm here to tell you my average speed is in the order of B/s, and also unstable:

better said "Maverick (iwl3945): 0-3 Mbps".

Thanks, Christopher Salinardi, for your suggestion and repo, I'm going to have a try tomorrow.

Eric Appleman (erappleman) wrote :

Then forget I even said up to 3Mb. I was being needlessly generous.

99% of the time, it's 1Mb or less.

Eric Appleman (erappleman) wrote :

I have found the regression window.

2.6.35-rc2: 20 Mbps
2.6.35-rc3: 2 Mbps

Some commit between these two releases broke the driver.

Eric Appleman (erappleman) wrote :

I've found 2 candidate commits.

a6866ac93e6cb68091326e80b4fa4619a5957644
1402364162afbaac1b8a74ee21aeb013e817ac7d

The only changes to the driver between the two release candidates.

Eric Appleman (erappleman) wrote :

2 more commits that I missed

7d47618a2ade0cb6d8a0b2597029c383c1662fa0
6db6340c42d027b6364d49fa99d69019aca24de4

Jonathan Kulp (jonlancekulp) wrote :

I wonder if it would be possible to pull the code, revert those commits locally, build and install the new kernel. Seems likely to break something but might be worth a try.

I tried the ndiswrapper, but finally had to disable it. I have a Thinkpad T61 and it was hard to find a driver that worked. The ones that worked were really unstable and I was getting a lot of authentication errors. Sticking with the 2.6.32 kernel for now.

Donny Kurnia (donnykurnia) wrote :

@Christopher, try the Dell driver that found in this thread:
http://ubuntuforums.org/showthread.php?t=1504211

It's working well with ndiswrapper. The driver from Thinkpad is not compatible with ndiswrapper. I'm using R61 (still lucid) but I can make ndiswrapper worked (just in case if this bug will never got resolved).

Radosław Piliszek (radzio) wrote :

@Eric Appleman:
Only the first two commits affect the driver, the rest applies to iwlagn only.

I will try to find out which commit makes it this slow.

Radosław Piliszek (radzio) wrote :

I reverted: a6866ac93e6cb68091326e80b4fa4619a5957644
and recompiled kernel but with no luck (problem persists) so it seems to be the 2nd one.

I am checking it.

Radosław Piliszek (radzio) wrote :

It seems it's a fault of my router<->notebook pair.
Even Windows has low transfers :(
I guess I'm just unlucky.

Radosław Piliszek (radzio) wrote :

Ah, I was too fast to say that. In Linux speeds go down to around 0 so yes there is a problem.

Eric Appleman (erappleman) wrote :

Any luck reverting the "fix internal scan" commit?

Ryan C. (ryanc-austin) wrote :

Strange - I ran from a Live CD and didn't experience the problem (got ~10 Mbps download). So I upgraded my hard drive from 10.04 and also didn't experience the problem. Then I put in a new hard drive and installed 10.10 fresh, and the problem started happening! Same laptop, just a different (newer/faster) hard drive. Getting about 1.5-3 Mbps!

Eric Appleman (erappleman) wrote :

The speed decrease isn't always instant. It can take a few minutes, even on the LiveCD/LiveUSB.

Just keep hammering the wireless with speed tests and casual browsing.

Radosław Piliszek (radzio) wrote :

I started by fixing Windows. Seems it was using a buggy driver. Now it has proper speeds (around 3MBytes/s).
So there is now a base for comparison.

I will test reverting the 1st and then 2nd commit again, taking into account that "speed decrease isn't always instant" - I just experienced it. Launched Kubuntu 10.10 and whoa, it's OK, I went out and after coming back - what the... (speed around 3 Mbit/s not MBytes/s)

My notebook isn't a speed daemon - recompilation takes a lot of time.

I'll post results today - I hope.

I gave up.
I bought a new intel n-draft wifi PCIE Module for 12EUR and replaced my 3945.

Regards olli
-----Original Message-----
From: Radosław Piliszek <email address hidden>
Sender: <email address hidden>
Date: Mon, 27 Dec 2010 10:32:22
To: <email address hidden>
Reply-To: Bug 621265 <email address hidden>
Subject: [Bug 621265] Re: Slow Wireless Connection in Intel 3945abg

I started by fixing Windows. Seems it was using a buggy driver. Now it has proper speeds (around 3MBytes/s).
So there is now a base for comparison.

I will test reverting the 1st and then 2nd commit again, taking into
account that "speed decrease isn't always instant" - I just experienced
it. Launched Kubuntu 10.10 and whoa, it's OK, I went out and after
coming back - what the... (speed around 3 Mbit/s not MBytes/s)

My notebook isn't a speed daemon - recompilation takes a lot of time.

I'll post results today - I hope.

--
You received this bug notification because you are a direct subscriber
of the bug.
https://bugs.launchpad.net/bugs/621265

Title:
  Slow Wireless Connection in Intel 3945abg

Status in “linux” package in Ubuntu:
  Confirmed
Status in “linux” source package in Maverick:
  Confirmed

Bug description:
  With latest daily-live Maverick (2010-08-20), my wireless connection with Intel 3945abg never go over 3mbps speed.
I try this in local lan and in internet.
It seems like a regression about iwl3945 driver, i had a similar problem with older kernel where wireless speed was limited to 1mbps, with k/ubuntu 10.04 and 2.6.32 kernel this problem was disappear.

Some information:
lsb_release -rd:
Description: Ubuntu maverick (development branch)
Release: 10.10

uname -a:
Linux ubuntu 2.6.35-16-generic #22-Ubuntu SMP Tue Aug 17 02:21:03 UTC 2010 x86_64 GNU/Linux

dmesg | grep 3945:

[ 27.977578] iwl3945: Intel(R) PRO/Wireless 3945ABG/BG Network Connection driver for Linux, in-tree:s
[ 27.977583] iwl3945: Copyright(c) 2003-2010 Intel Corporation
[ 27.977678] iwl3945 0000:02:00.0: PCI INT A -> GSI 17 (level, low) -> IRQ 17
[ 27.977693] iwl3945 0000:02:00.0: setting latency timer to 64
[ 28.043199] iwl3945 0000:02:00.0: Tunable channels: 13 802.11bg, 23 802.11a channels
[ 28.043205] iwl3945 0000:02:00.0: Detected Intel Wireless WiFi Link 3945ABG
[ 28.043366] iwl3945 0000:02:00.0: irq 43 for MSI/MSI-X
[ 28.185681] phy0: Selected rate control algorithm 'iwl-3945-rs'
[ 28.523764] iwl3945 0000:02:00.0: loaded firmware version 15.32.2.9

iwconfig:
wlan0 IEEE 802.11abg ESSID:"Dorema"
          Mode:Managed Frequency:2.472 GHz Access Point: 00:1A:92:11:1C:C7
          Bit Rate=54 Mb/s Tx-Power=15 dBm
          Retry long limit:7 RTS thr:off Fragment thr:off
          Power Management:off
          Link Quality=68/70 Signal level=-42 dBm
          Rx invalid nwid:0 Rx invalid crypt:0 Rx invalid frag:0
          Tx excessive retries:0 Invalid misc:0 Missed beacon:0

My access point is Asus WL-600g

To unsubscribe from this bug, go to:
https://bugs.launchpad.net/ubuntu/+source/linux/+bug/621265/+subscribe

Radosław Piliszek (radzio) wrote :

Ok, now I'm 100% sure a6866ac93e6cb68091326e80b4fa4619a5957644 isn't what we are looking for.
Going for the 2nd.

Radosław Piliszek (radzio) wrote :

I tried reverting the 2nd one. No results.

As these are only commits affecting iwl3945 I think we are stuck.

Are you sure you have found the right regression window?

Donny Kurnia (donnykurnia) wrote :

@Eric and @Radosław , can you share the commit log and info here, who commit that changes, is he also subscribed to this bug report or not?

Radosław Piliszek (radzio) wrote :

http://git.kernel.org/?p=linux/kernel/git/stable/linux-2.6.35.y.git;a=commit;h=a6866ac93e6cb68091326e80b4fa4619a5957644
http://git.kernel.org/?p=linux/kernel/git/stable/linux-2.6.35.y.git;a=commit;h=1402364162afbaac1b8a74ee21aeb013e817ac7d

I strongly doubt it could be a6866ac93e6cb68091326e80b4fa4619a5957644 as the same commit went to 2.6.34 tree and the latest 2.6.34.7 works fine.

Anyway, I tried reverting both with no results.

Maybe it's not directly connected with iwl3945's code?

I will do some more tests in Gentoo.

Radosław Piliszek (radzio) wrote :

I've tested Linux 2.6.36.2 and it works fine (constant 20Mbit/s).
However I used Gentoo. I'll try with 2.6.35.
(maybe it's something just Ubuntu-related)

Jonathan Kulp (jonlancekulp) wrote :

I built and installed 2.6.36.2 on Mint 10 and wireless is still slow: 2.91 Mbps down, 3.59 Mbps up.

http://www.speedtest.net/result/1087803303.png

I get 20+ Mbps on Windows with wireless connection, 29 Mbps on ethernet connection in either Win or any Linux kernel.

Radosław Piliszek (radzio) wrote :

Thanks for info about 2.6.36.2 on Mint.

2.6.35.10 works perfectly fine on Gentoo.

I think the problem is somewhere else. I mean it can be actually a problem with kernel but only when used with some software etc.
In Gentoo I use wpa_supplicant and dhcpcd. IIRC Ubuntu uses NetworkManager.

Ok, two tasks to be done:
1) Test Ubuntu/Mint w/o NetworkManager - use manual connection handling with wpa_supplicant.
2) Test 2.6.34.7 on Ubuntu/Mint.

Summary:
Gentoo: 2.6.34/35/36 OK
Ubuntu: 2.6.35/36 Bad

Jonathan Kulp (jonlancekulp) wrote :

I will try the wpa_supplicant thing in a moment. Do you think it could have something to do with the new network manager daemon handling? I know that starting/stopping it used to be "/etc/init.d/network-manager start/stop" and now it's just "restart networkmanager" or something like that.

Radosław Piliszek (radzio) wrote :

I doubt. It must be something more internal. New service management stuff wouldn't cause problems like this one.
Especially as it seems the problem is related to iwl3945 only. However, are we sure it applies only to iwl3945?

I have also a question (as I'm now running Gentoo and want to play with NetworkManager in it): what is the version of ucode in Ubuntu?

Radosław Piliszek (radzio) wrote :

Another idea came to my mind: maybe it's Ubuntu's wpa_supplicant that is buggy and doesn't work with latest kernel patches?

Jonathan Kulp (jonlancekulp) wrote :

Maybe but why would it only affect this wireless card? Anyway I'm downloading Fedora 14 to try it on a live CD. It'll have a pretty new kernel.

Jonathan Kulp (jonlancekulp) wrote :

Well, it's just as slow in Fedora 14 as in Mint 10. F14 had kernel 2.6.35.6 IIRC.

with respect to wpa supplicant, are unencrypted connections affected? also, are we now considering the mac80211 subsystem. Finally, is there anything between 2.6.34.7 and 2.6.35-rc1 that we could be missing?

----------
Sent from the Verizon network using Mobile Email

------Original Message------
From: Jonathan Kulp <email address hidden>
To: <email address hidden>
Date: Tue, Dec 28, 10:15 PM +0000
Subject: [Bug 621265] Re: Slow Wireless Connection in Intel 3945abg

Well, it's just as slow in Fedora 14 as in Mint 10. F14 had kernel
2.6.35.6 IIRC.

--
You received this bug notification because you are a direct subscriber
of the bug.
https://bugs.launchpad.net/bugs/621265

Title:
  Slow Wireless Connection in Intel 3945abg

Daniel Thomas (drt24) wrote :

The Fedora bug report is here: https://bugzilla.redhat.com/show_bug.cgi?id=654599 and there is a possibly related one here: https://bugzilla.redhat.com/show_bug.cgi?id=653437
They don't seem to have managed to fix the bug or locate it precisely.

Jonathan Kulp (jonlancekulp) wrote :

On Mint 10 I have wpa_supplicant v0.6.10

Anyone know what version is installed on Ubuntu 10.04 or Mint 9? One of the comments on the redhat bugzilla suggested it might be due to newer version of wpa_supplicant.

Jonathan Kulp (jonlancekulp) wrote :

Ubuntu 10.04 has wpasupplicant v0.6.9. I tried compiling and installing this on Mint 10 (based on Ubuntu 10.10) and it totally jacked up my networking. Couldn't connect at all after that. Will have to restore Mint partition from clone backup made right before fiddling around with it.

Radosław Piliszek (radzio) wrote :

@Eric: 2.6.34.7 isn't older than 2.6.35-rc1 and actually there don't seem to be any more important code changes in iwl3945 driver. I haven't tested unencrypted connections because I can't allow them in my environment.

@Daniel: Thanks.

@Jonathan: Yes, they actually suggested it for a guy that has problems with setting up the device but they also see a connection between that and our problem.

I think it really might be wpa_supplicant. In Gentoo I have 0.7.2 with their further patches. There is also a stock 0.6.10 available in Portage tree so I'll try it later.

Could you please try 0.7.x in Ubuntu/Fedora?

Radosław Piliszek (radzio) wrote :

0.6.10 works fine in Gentoo.

Jonathan Kulp (jonlancekulp) wrote :

I just tried with unencrypted wireless connection and there's no improvement in speed.

Radosław Piliszek (radzio) wrote :

You did it with NetworkManager, don't you?
It might use wpa_supplicant for unencrypted as well.

You could try disabling NetworkManager at all and using iwconfig+dhcpcd (or dhclient).

Jonathan Kulp (jonlancekulp) wrote :

Yes I used NetworkManager. I just finished bulding/installing wpa_supplicant 0.7.3 and the problem persists, at least when using networkmanager. Will try again with command-line tools.

Jonathan Kulp (jonlancekulp) wrote :

Sorry but I'm totally failing to get a connection with iwconfig + dhclient. Funny I used to be able to do it on Arch. :shrug:

Radosław Piliszek (radzio) wrote :

Do you mean that you don't know how or that it doesn't work?

Radosław Piliszek (radzio) wrote :

I used Mint10 LiveDVD.
After killing dbus (to kill all NM stuff) [X got killed as well of course] I went to the console and manually set up a connection with wpa_supplicant and dhclient.
I used wget for download and got speed 16-20Mbit/s during download of 800MByte file.

Could anyone confirm this as well?

Eric Appleman (erappleman) wrote :

I'll give that a try later today. I'm also going to see if a NM-less environment with Wicd helps at all.

BTW, I fail to see how the wpa_supplicant itself could be at fault.

For almost all of my kernel version testing, I've bee using a Natty filesystem and packages.

Radosław Piliszek (radzio) wrote :

I've already excluded wpa_supplicant. (my tests on Gentoo + Jonathan's report)
I included it because it handles wireless connections for NetworkManager.

Currently I'm focusing on NetworkManager.

Can you think of other differences between Ubuntu/Fedora and Gentoo that could matter?

Eric Appleman (erappleman) wrote :

Radosław, still slow with your cli-only environment using wpa_suppplicant. I couldn't replicate your speed increase. I had killed the dbus service and everything.

Can you go through the steps that permitted full speeds in your setup?

Radosław Piliszek (radzio) wrote :

Ctrl+Alt+F1
sudo -i
pkill dbus
wpa_passphrase ESSID > myconf
(now write the passphrase) RETURN
wpa_supplicant -iwlan0 -cmyconf -Dwext -B
dhclient wlan0
wget .....

krader (apictor) wrote :

I've uninstalled network-manager and installed Wicd, and the first test was hard: just restarted, connected with Wicd and try to run a web speed test, with network info window opened; speed drops down to 1Mb and then directly stops working. So I think the problem is not related to network-manager. (Ubuntu 10.10 with 2.6.35)

I should report that I do not experience the bug you mention (on a Thinkpad T60, with the intel device in question) after upgrading from 10.04 to 10.10 (maverick).

I tried several different WiFi-settings, different encryptions and never experienced any slowdown at all.

My kernel is 2.6.35-24-generic and my wpa_supplicant is 0.6.10-2.
NetworkManager is used, and has version 0.8.1+git.20100810t184654.ab580f4-0ubuntu2

I hope this helps.

Jonathan Kulp (jonlancekulp) wrote :

Well I've found my solution for this. Just got new wireless card, Intel 5100, for $10 on eBay. Speed up and down with new card is 20Mbps, just like on Windows. Even with older kernel 2.6.32 I only got 12Mbps max on Intel 3945. I'm glad to see the back of this bug.

Mtt.Castelli (mtt.castelli) wrote :

surely jou're joking, Jonathan.

Nobody should be constricted to open his hardware, a notebook in particular, to make it works. Regardless from how much the expense is cheap.

Jonathan Kulp (jonlancekulp) wrote :

Not joking at all for myself. Not a solution for everyone probably,
but I'm very happy now. I enjoy opening up hardware. Replacing
wireless card is trivial compared to the soundcard replacement I did a
few months ago. :) Main thing is that I'm not even thinking about
this bug anymore and I'm glad about it.

Jon

On Sat, Jan 8, 2011 at 9:37 AM, Mtt.Castelli <email address hidden> wrote:
> surely jou're joking, Jonathan.
>
> Nobody should be constricted to open his hardware, a notebook in
> particular, to make it works. Regardless from how much the expense is
> cheap.
>
> --
> You received this bug notification because you are a direct subscriber
> of the bug.
> https://bugs.launchpad.net/bugs/621265
>
> Title:
>  Slow Wireless Connection in Intel 3945abg
>
> Status in The Linux Kernel:
>  Unknown
> Status in “linux” package in Ubuntu:
>  Confirmed
> Status in “linux” source package in Maverick:
>  Confirmed
> Status in “linux” package in Fedora:
>  Unknown
>
> Bug description:
>  With latest daily-live Maverick (2010-08-20), my wireless connection with Intel 3945abg never go over 3mbps speed.
> I try this in local lan and in internet.
> It seems like a regression about iwl3945 driver, i had a similar problem with older kernel where wireless speed was limited to 1mbps, with k/ubuntu 10.04 and 2.6.32 kernel this problem was disappear.
>
> Some information:
> lsb_release -rd:
> Description:    Ubuntu maverick (development branch)
> Release:        10.10
>
> uname -a:
> Linux ubuntu 2.6.35-16-generic #22-Ubuntu SMP Tue Aug 17 02:21:03 UTC 2010 x86_64 GNU/Linux
>
> dmesg | grep 3945:
>
> [   27.977578] iwl3945: Intel(R) PRO/Wireless 3945ABG/BG Network Connection driver for Linux, in-tree:s
> [   27.977583] iwl3945: Copyright(c) 2003-2010 Intel Corporation
> [   27.977678] iwl3945 0000:02:00.0: PCI INT A -> GSI 17 (level, low) -> IRQ 17
> [   27.977693] iwl3945 0000:02:00.0: setting latency timer to 64
> [   28.043199] iwl3945 0000:02:00.0: Tunable channels: 13 802.11bg, 23 802.11a channels
> [   28.043205] iwl3945 0000:02:00.0: Detected Intel Wireless WiFi Link 3945ABG
> [   28.043366] iwl3945 0000:02:00.0: irq 43 for MSI/MSI-X
> [   28.185681] phy0: Selected rate control algorithm 'iwl-3945-rs'
> [   28.523764] iwl3945 0000:02:00.0: loaded firmware version 15.32.2.9
>
> iwconfig:
> wlan0     IEEE 802.11abg  ESSID:"Dorema"
>          Mode:Managed  Frequency:2.472 GHz  Access Point: 00:1A:92:11:1C:C7
>          Bit Rate=54 Mb/s   Tx-Power=15 dBm
>          Retry  long limit:7   RTS thr:off   Fragment thr:off
>          Power Management:off
>          Link Quality=68/70  Signal level=-42 dBm
>          Rx invalid nwid:0  Rx invalid crypt:0  Rx invalid frag:0
>          Tx excessive retries:0  Invalid misc:0   Missed beacon:0
>
> My access point is Asus WL-600g
>
> To unsubscribe from this bug, go to:
> https://bugs.launchpad.net/linux/+bug/621265/+subscribe
>

--
Jonathan Kulp
http://www.jonathankulp.com

JD (dugganjl) wrote :

My solution was to change the router's encryption mode from WPA2 Personal - TKIP or AES to WPA2 Personal - AES.
Changing to AES Encryption fixed it immediately.

Router: Linksys WRT160N
Intel 3945abg
Ubuntu 10.04

Nick Broadhurst (hou1nxb) wrote :

Hi folks, new to Linux. Just wanted to add that I experience the bug when router is on when computer is booted (normal situation of course.) However, if I reboot router (Linksys WRT54G ver6 running WEP) while PC is running, I full connection speed. Tested it several times to verify. Weird!

Nick Broadhurst (hou1nxb) wrote :

UPDATE: After browsing for 10-15 minutes with full speed, the slow connection has mysteriously returned just like that. Hmmmmm.....

Radosław Piliszek (radzio) wrote :

Because speed's decrease is not immediate.

Eyal Susser (eyal-susser) wrote :

Am seeing the same problem with 2.6.35-24-generic.

If I connect eth0, speeds are back to normal. If I use wlan0, speed is slow, and sometimes the connection fails altogether. I installed Maverick and updated immediately after the installation as I was prompted to do. This was a fresh install on a newly formatted drive.

Raju (raju) wrote :

Hi All,

I have the impacted wireless card. I booted my laptop using the 10.10 live CD to try it out and see if my laptop is impacted by this bug. After booting I connected to the wireless network, checked connection information and it was connected at 54Mbps. Used the net for 5 mins, working fine. Then left the machine for 20-30mins. Came back and checked connection information and it showed 1Mbps but instantly refreshed the value to 54Mbps. Since then I have been using the net and been checking connection info every few mins, it has been stable at 54Mbps (except once when it showed 48Mbps) for the last 30mins.

Does this mean my laptop will work fine after upgrading from 10.04 to 10.10?

Thanks,
Raju.

Raju (raju) wrote :

Hi All,

As per my previous update, I have been using my laptop on wireless for over an hour now. I have been browsing the net, played a movie trailer from my NAS drive and a few other things just to keep the wireless connection active. Have also been checking the speed in connection information and it has been stable at 48-54Mb/s.

Does this mean my laptop will work fine after upgrading from 10.04 to 10.10?

Thanks,
Raju.

Pepe Lebuntu (majagray75) wrote :

Hi Raju,

I'm not THAT much of an expert, that I've had seriously less problems
with my laptop until I switched to 10.10.

Maranatha,
Matt.

On 19/01/11 11:04, Raju wrote:
> Hi All,
>
> As per my previous update, I have been using my laptop on wireless for
> over an hour now. I have been browsing the net, played a movie trailer
> from my NAS drive and a few other things just to keep the wireless
> connection active. Have also been checking the speed in connection
> information and it has been stable at 48-54Mb/s.
>
> Does this mean my laptop will work fine after upgrading from 10.04 to
> 10.10?
>
> Thanks,
> Raju.
>

--

"First of all, consideration purifies the very fountain, that is the
mind, from which it springs. Then it governs the emotions, directs our
actions, corrects excesses, softens the manners, adorns and regulates
the life, and, lastly, bestows the knowledge of things divine and human
alike. It is consideration that brings order out of disorder, puts in
the links, pulls things together, investigates mysteries, traces the
truth, weighs probabilities, and exposes shams and counterfeits."

Bernard of Clairvaux, /On Consideration/, 1149.

Radosław Piliszek (radzio) wrote :

Could everyone post the output of "lspci -vnn | grep -A 1 Wireless"?
Please also state if you experience the problem or not.
Thank you.

Laszlo Suto (laszlo-suto) wrote :

lspci -vnn | grep -A 1 Wireless output:
10:00.0 Network controller [0280]: Intel Corporation PRO/Wireless 3945ABG [Golan] Network Connection [8086:4222] (rev 02)
 Subsystem: Hewlett-Packard Company Device [103c:135b]

Radosław Piliszek (radzio) wrote :

Please, everyone capable to do so, try https://bugzilla.redhat.com/show_bug.cgi?id=654599#c23
and tell if it fixes problem.

Raju (raju) wrote :

Hi All,

Further update to my post #181. The next day I again booted up from the live CD and left the system running all day. I monitored the connection speed during activity and with no activity. The speed displayed in the connection information dialog dropped every few minutes to 1Mb/s but for a very short period (1-5seconds) and then it would jump back up to 54Mb/s.

Whenever I saw it at 1Mb/s I tried to access something on my LAN or internet and the speed jumped back to 54Mb/s. Whether it was because of activity on the laptop or because it was anyway jumping up within few seconds, difficult to tell. At all times I was able to use internet at normal speeds. I could not do a speed test because I was not able to install flash plugin for some reason , maybe because I was booted from a live CD.

Still not confident I want to upgrade to 10.10 so will stick with 10.04.

Thanks,
Raju.

Radosław Piliszek (radzio) wrote :

@Raju: That is normal. When there is no data sent it usually shows the minimum (1Mb/s).
This bug is about speed drop that happens after some time of download and which only reboot can recover from.

Raju (raju) wrote :

Radosław,

Thanks for your reply. Tonight I will boot from live CD and try a big download to see how it behaves.

Thanks,
Raju.

Espen (espenbe) wrote :

espenbe@ministerial:~$ lspci -vnn | grep -A 1 Wireless
0c:00.0 Network controller [0280]: Intel Corporation PRO/Wireless 3945ABG [Golan] Network Connection [8086:4222] (rev 02)
 Subsystem: Intel Corporation Device [8086:1021]
espenbe@ministerial:~$

Nick B. (futurepilot) wrote :

$ lspci -vnn | grep -A 1 Wireless
02:00.0 Network controller [0280]: Intel Corporation PRO/Wireless 3945ABG [Golan] Network Connection [8086:4222] (rev 02)
    Subsystem: Hewlett-Packard Company Device [103c:135b]

I experience this problem.

On 01/21/2011 06:35 AM, Radosław Piliszek wrote:
> Could everyone post the output of "lspci -vnn | grep -A 1 Wireless"?
> Please also state if you experience the problem or not.
> Thank you.
>

fliebel (zebrametvlekken) wrote :

I can confirm switching from WPA2/WPA TKIP or WPA2 / TKIP mode to WPA2 - AES fixes the problem.

Nick B. (futurepilot) wrote :

Not for me. Have you tested it for an extended period of time?

On 01/21/2011 02:29 PM, fliebel wrote:
> I can confirm switching from WPA2/WPA TKIP or WPA2 / TKIP mode to WPA2 -
> AES fixes the problem.
>

Jg-staffel (jg-staffel) wrote :

$ lspci -vnn | grep -A 1 Wireless
03:00.0 Network controller [0280]: Intel Corporation PRO/Wireless 3945ABG [Golan] Network Connection [8086:4222] (rev 02)
 Subsystem: Intel Corporation PRO/Wireless 3945ABG Network Connection [8086:1001]
 Physical Slot: 33

Espen (espenbe) wrote :

I forgot to mention that I also experience the problem.

Radosław Piliszek (radzio) wrote :

@fliebel, Nick B.: It does not help here either.

SteBo (stebo) wrote :

stefan@rattle:~$ lspci -vnn | grep -A 1 Wireless
0c:00.0 Network controller [0280]: Intel Corporation PRO/Wireless 3945ABG [Golan] Network Connection [8086:4222] (rev 02)
        Subsystem: Intel Corporation Device [8086:1021]

I also experience the problem and are currently using Linux 2.6.32-21-generic from Lucid (10.04) under Maverick (10.10) as a workaround.

Eric Appleman (erappleman) wrote :

For the 100th time, I'd like to debunk the WPA2 AES "fix".

1. It does not work, period.
2. This bug affects both encrypted and unencrypted connections of all types.

Eric Appleman (erappleman) wrote :

Also...

eric@kingfisher:~$ lspci -vnn | grep -A 1 Wireless
0c:00.0 Network controller [0280]: Intel Corporation PRO/Wireless 3945ABG [Golan] Network Connection [8086:4222] (rev 02)
 Subsystem: Intel Corporation Device [8086:1020]

Radosław Piliszek (radzio) wrote :

I will post tomorrow a linux-image with plcp patch applied so that you all could test it and report.

fliebel (zebrametvlekken) wrote :

Alright, let me get you some beter intel on the AES fix;
First of all, im using wireless channel 9, 40mhz band. And its a Comtrend Multi-DSL vDSL modem (wireless-g and wireless-n).

WPA2-PSK AES:
Connection stable and up to speed. once in a while i get the 1mbit bug. Hit the Wifi button on the notebook, and reconnect.. fixed!. Happens once a day or so. PC idleness seems to trigger it.

WPA2-PSK TKIP:
Instant 1mbit cap on download. Upload is fine though (up to 5mbit here).

Alright, it is not a real fix.. but it should give a hint on the correlation between encryption and the bug. The point is, my WiFi is fine with AES (20mbit down).. and total garbage with TKIP. The AES requires a WiFi restart every once in a while though.

Device lspci -v
10:00.0 Network controller: Intel Corporation PRO/Wireless 3945ABG [Golan] Network Connection (rev 02)
 Subsystem: Hewlett-Packard Company Compaq 6710b or nx9420 Notebook
 Flags: bus master, fast devsel, latency 0, IRQ 45
 Memory at e4100000 (32-bit, non-prefetchable) [size=4K]
 Capabilities: [c8] Power Management version 2
 Capabilities: [d0] MSI: Enable+ Count=1/1 Maskable- 64bit+
 Capabilities: [e0] Express Legacy Endpoint, MSI 00
 Capabilities: [100] Advanced Error Reporting
 Capabilities: [140] Device Serial Number 00-1b-77-ff-ff-50-35-59
 Kernel driver in use: iwl3945
 Kernel modules: iwl3945

Ryan C. (ryanc-austin) wrote :

ryan@curcio:~$ lspci -vnn | grep -A 1 Wireless
0c:00.0 Network controller [0280]: Intel Corporation PRO/Wireless
3945ABG [Golan] Network Connection [8086:4222] (rev 02)
     Subsystem: Intel Corporation Device [8086:1020]

I do experience the problem.

On 01/21/2011 05:35 AM, Radosław Piliszek wrote:
> lspci -vnn | grep -A 1 Wireless

jonathan@minty ~/Desktop $ lspci -vnn | grep -A 1 Wireless
0c:00.0 Network controller [0280]: Intel Corporation PRO/Wireless 3945ABG [Golan] Network Connection [8086:4222] (rev 02)
 Subsystem: Intel Corporation Device [8086:1020]
jonathan@minty ~/Desktop $ uname -a
Linux minty 2.6.35-23-generic #41-Ubuntu SMP Wed Nov 24 10:18:49 UTC 2010 i686 GNU/Linux

I experience the slowdown as described.

Radosław Piliszek (radzio) wrote :

@fliebel: Please post output of: "lspci -vnn | grep -A 1 Wireless"
I always use WPA2-AES. It seems to give you a little fix but not for the others.

@all of you:
This bug seems to be very nasty: I can kill it by connecting with NetworkManager, disabling NM and connecting using command line tools (wpa_supplicant, dhclient). For SilvioTO on Redhat's bugzilla plcp patch helped.

I will prepare you later today a deb package with plcp patch you could install.

fliebel (zebrametvlekken) wrote :

lspci -vnn | grep -A 1 Wireless
10:00.0 Network controller [0280]: Intel Corporation PRO/Wireless 3945ABG [Golan] Network Connection [8086:4222] (rev 02)
 Subsystem: Hewlett-Packard Company Compaq 6710b or nx9420 Notebook [103c:135c]

nicholas (nicholas-linpro) wrote :

lspci -vnn | grep -A 1 Wireless
03:00.0 Network controller [0280]: Intel Corporation PRO/Wireless 3945ABG [Golan] Network Connection [8086:4227] (rev 02)
        Subsystem: Intel Corporation ThinkPad R60e/X60s [8086:1011]

Affects me too. Did not help turning off TKIP and rebooting everything. Will gladly try .debs to see if problem varies :-)

nicholas (nicholas-linpro) wrote :

installing http://packages.ubuntu.com/lucid/linux-image-2.6.32-21-generic and booting that kernel fixes problem.

nicholas (nicholas-linpro) wrote :

Or not. The first speedtest.net passed high aces with 15 Mbits, the second showed the slow down to 1Mbit. Now I'm just confused :-/

Radosław Piliszek (radzio) wrote :

The patch copied from Redhat's bugzilla.

Radosław Piliszek (radzio) wrote :

A link to compiled i386 Ubuntu kernel with plcp patch.
http://piliszek.tk/linux-image-2.6.35-24-generic_2.6.35-24.42_i386.deb

Eric Appleman (erappleman) wrote :

Initial short-term results with the PLCP patched kernel on a 15Mbit connection are quite promising.

I'll withhold a more solid judgment until I do some long-term iso downlods on my 30Mbit connection at home.

lspci -vnn | grep -A 1 Wireless
0c:00.0 Network controller [0280]: Intel Corporation PRO/Wireless 3945ABG [Golan] Network Connection [8086:4222] (rev 02)
 Subsystem: Intel Corporation Device [8086:1020]

With the new patched kernel, I was able to get speeds up to 4.36 Mb/s on speedtest.net. Still not seeing speeds equal to Windows, or Android speed tests.

Eric Appleman (erappleman) wrote :

After further testing, I can say that speeds the driver is still underperforming in terms of speed and weak signal management.

iwl3945: 10 Mbps
ndiswrapper: 23 Mbps

iwl3945 speeds are better, but still slower than they should be.

Radosław Piliszek (radzio) wrote :

But the extremely low speeds are gone, aren't they?

To be honest, this fix does NOT help me at all. It has only helped SilvioTO.

Please report.

Eric Appleman (erappleman) wrote :

Yes, there is a quantifiable improvement.

Unpatched iwl3945: 2 Mbps
Patched iwl3945: 10 Mbps

There's still a long way to go though.

Radosław Piliszek (radzio) wrote :

I hope someone would explain why it does not work for me. :-(

Eric Appleman (erappleman) wrote :

Becausing taming this bug sucks.

nicholas (nicholas-linpro) wrote :

http://piliszek.tk/linux-image-2.6.35-24-generic_2.6.35-24.42_i386.deb did not fix it for me.

I booted a lucid live cd, 10.04.1, and saw the same slowdown there actually to my surprise.

Setting up the connection manually with wpa_supplicant didn't help.

I'm now using ndiswrapper and netw4x32.inf. It's slow initializing, but when it connects I get the expected 16Mbit download speeds.

03:00.0 Network controller [0280]: Intel Corporation PRO/Wireless 3945ABG [Golan] Network Connection [8086:4227] (rev 02)
        Subsystem: Intel Corporation ThinkPad R60e/X60s [8086:1011]

BIOS Information
        Vendor: LENOVO
        Version: 7BETD7WW (2.18 )

Radosław Piliszek (radzio) wrote :

@Nicholas: I've just tested 10.04.1 (before reading your post; I'm now testing all distros I have burnt CDs of)
and it's buggy as well.

You seem to experience similar bug to mine as PLCP patch doesn't help you.

wpa_supplicant helps me as described above: "I can kill it [the bug] by connecting with NetworkManager, disabling NM [completely!] and connecting using command line tools (wpa_supplicant, dhclient)."

But I don't think it's a nice workaround at all.

Radosław Piliszek (radzio) wrote :

Till now I've tested 5 OSes:

4 are buggy:
Fedora 13/14
Ubuntu 10.04/10.10

The 5th is not because it does not use NetworkManager (it is Mandriva 2010.1).
Also Gentoo (which I use w/o NM as well) is free of this bug.

This makes me sure it is NetworkManager that causes all this hell for me.

@nicholas: Could you try Mandriva?

Radosław Piliszek (radzio) wrote :

Also affected:
Ubuntu 9.04/9.10
openSuSE 11.3
and probably others using NetworkManager.

That's odd - I've used Ubuntu (so NM as well) with Atheros-based chips and everything was fine.
How could NM depend on underlying hardware that much?

nicholas (nicholas-linpro) wrote :

Maybe you could doublecheck that bypassing NM and using wpa_supplicant directly gives decent download speeds for a whole iso? I often see everything ok the first 100MB's orso, and then it drops.

Downloading mandriva now :-)

Eric Appleman (erappleman) wrote :

Well, a Wicd-only environment doesn't help.

I need to remember how to do a terminal-only connection.

Radosław Piliszek (radzio) wrote :

@nicholas: I did. I downloaded twice a 700MB iso.

@Eric:
wpa_passphrase SSID > myconf
wpa_supplicant -Dwext -iwlan0 -cmyconf -B
dhclient wlan0

Radosław Piliszek (radzio) wrote :

Ah, forgot to say that wpa_passphrase wants your passphrase to be written to stdin.

nicholas (nicholas-linpro) wrote :

@Radosław: Mandriva One 2010.2 KDE worked like a charm with fast downloads. Kubuntu 10.10, with no NetworkManager as far as I could understand, was slow.

nicholas (nicholas-linpro) wrote :

I found a source of error in my testing, I had compat-wireless package installed.

ii linux-backports-modules-compat-wireless-2.6.36-2.6.35-24-ge - compat-wireless Linux modules for version 2.6.35 on x86/x86_64

This brings it's own iwl3945.ko, and the 0002-iwl3945-remove-check_plcp_health.patch didn't take effect in my runs above.

iperf runs towards the local GW:
windows: 20 Mbits/s
2.6.35-23-generic (unpatched for check_plcp_health): 2-4Mbits/s
2.6.35-24 (patched for check_plcp_health): 18Mbits/s

I can live with the -10% perfomance hit compared to windows.

Radosław Piliszek (radzio) wrote :

Why doesn't it help me but Mandriva?

Kubuntu has NetworkManager enabled by default.

Stefan Bader (smb) wrote :

In the linked Redhat bugzilla Stanislaw is asking for a test run with three patches. Just to be sure (maybe it is mentioned somewhere but I have slight problems to read through all the comments): the test kernel that is used, does that contain all three of them? If not it would be good to have testing there is to put down the results in at least the Redhat bugzilla.

Generally about network manager: that may just use certain functionality that is not used without. For example (likely unrelated to this issue) it does scans, even while connected, to update the list of access points.

Mtt.Castelli (mtt.castelli) wrote :

matteo@Panurge:~$ lspci -vnn | grep -A 1 Wireless
0c:00.0 Network controller [0280]: Intel Corporation PRO/Wireless 3945ABG [Golan] Network Connection [8086:4222] (rev 02)
 Subsystem: Intel Corporation Device [8086:1021]

kdekda (teabof) wrote :

The patch from Radosław Piliszek (#209) seems to work on my system. I've downloaded two isos and the speed is now more elevated (not like windows), about 400KB/s (before was about 100 KB/s)

Radosław Piliszek (radzio) wrote :

@kdekda: Could you post the output of "lspci -vnn | grep -A 1 Wireless" and try Mandriva Linux?

Jg-staffel (jg-staffel) wrote :

How to apply patch from post #208 to Ubuntu 10.10?

Radosław Piliszek (radzio) wrote :

@Jg-staffel:
If you are not familiar with kernel compiling, you should try the compiled kernel (if you have i386) from #209.
If you want to try (or if you use x86_64), follow these instructions:
https://wiki.ubuntu.com/Kernel/BuildYourOwnKernel
and BEFORE you start compilation, put the patch file in kernel source`s directory and do:
patch -p1 < patch_filename_here
It should tell you if it got applied properly.
After that - install the generated packages.

kdekda (teabof) wrote :

davide@notebook:~$ lspci -vnn | grep -A 1 Wireless
0c:00.0 Network controller [0280]: Intel Corporation PRO/Wireless 3945ABG [Golan] Network Connection [8086:4222] (rev 02)
        Subsystem: Intel Corporation Device [8086:1021]

i will try Mandriva, but not before thursday

Raju (raju) wrote :

All,

Further update to my post #188. I tested from live CD for a big download and found Wifi speeds mostly OK at 54MB/s, occasionally dropping to 48 or 36Mb/s. So I decided to upgrade last night and it has been working OK so far, touch wood!

$ lspci -vnn | grep -A 1 Wireless
06:00.0 Network controller [0280]: Intel Corporation PRO/Wireless 3945ABG [Golan] Network Connection [8086:4222] (rev 02)
 Subsystem: Intel Corporation Device [8086:1051]

Thanks,
Raju.

Radosław Piliszek (radzio) wrote :

And another one:
http://piliszek.tk/patch%232/linux-image-2.6.35-25-generic_2.6.35-25.44_i386.deb

Note that they replace each other. I had not found any info about how to change the version before I started compiling them.

But I can assure you that the next time I will upload a patched kernel, it will have custom version.

kdekda (teabof) wrote :

Test result with Mandriva 10.2 kde: the average download speed is about 500-550 KB/s, better then Kubuntu but worst then windows.

Sometimes, using kernel from Radosław Piliszek (#209), speed decreases till 100KB/s, like as before applying the patch. I will try the new patch asap!

Eric Appleman (erappleman) wrote :

Rad, both kernels max out at 5 Mbps.

Your PLCP kernel did better.

Radosław Piliszek (radzio) wrote :

That's interesting.
The 2nd undoubtedly has the PLCP patch. The 1st one has slightly modified PLCP patch which still helps SilvioTO.

Radosław Piliszek (radzio) wrote :

No results?

kdekda (teabof) wrote :

i'll be at home during the WE.

kdekda (teabof) wrote :

kernel from #236 has similar result with the one from #209

now i'll test #237

Radosław Piliszek (radzio) wrote :

This is already a helpful info.
#237 should, hopefully, perform even better.
Awaiting results.

aus (aus.) wrote :

From a the thread from a duplicated bug report (https://bugs.launchpad.net/ubuntu/+source/linux/+bug/340418/comments/40) I got the following work-around:

add to "/etc/modprobe.d/options-iwl3945.conf":
  options iwl3945 disable_hw_scan=0

For testing purpose do
  rmmod -f iwl3945 && modprobe iwl3945 disable_hw_scan=0

For me this seems to have 'fixed' the speed drop. If others could test this as well, it might help in narrowing down the exact problem.

Tried the workaround with little to no improvement. Download speeds were around 1-2mbps, far from what they should be.

p4tr1ck (pstedem) wrote :

@aus: At first that appeared to work for me, but after a period of time it went back to the previous slow speeds (<1 Mbps).

I'm using the 2.6.32-21 Lucid kernel in the way described here: http://ubuntuforums.org/showpost.php?p=10268752&postcount=5 to get solid speeds (~7-10 Mbps). I test each new kernel then go back to this one that works.

Radosław's kernel in #237 appears to fix the problem for me. I'm seeing 8-11mbps, which is equivalent to what I see in Windows and Android.

Radosław Piliszek (radzio) wrote :

@Brian: What about #236?

@Patrick: Does #236 or #237 help you?

@aus: disable_hw_scan=0 is the default.

Radosław Piliszek (radzio) wrote :

Please, all of you, try this: http://people.redhat.com/sgruszka/compat-wireless-2011-02-10-iwlwifi.tar.bz2
Instructions are inside in README.
If you have any questions, don't bother to ask.
Please make sure you didn't follow #245 as it conflicts with this test case. If you did, please revert your changes (e.g. remove "/etc/modprobe.d/options-iwl3945.conf").

Eric Appleman (erappleman) wrote :

ndiswrapper: 23 Mbps
compat-wireless iwlwifi: 4 Mbps with rare spikes up to 14 Mbps
2.6.38 iwlwifi: 2 Mbps

Eric Appleman (erappleman) wrote :

err...

2.6.38 iwlwifi: 4 Mbps

Eric Appleman (erappleman) wrote :

Upload is 5 Mbps for all cases.

Eric Appleman (erappleman) wrote :

btw, my connection is 30/5

kdekda (teabof) wrote :

kernel from #237 seems to be worst then the other..speed is not stable, max 500Kb/s, min 70 KB/s, but the average is under the last test

jhoechtl (johann-hoechtl) wrote :

I have been affected by this bug too, but you guys realy have to consider faulty routers. Bring your laptop to a different AP and try if this is the reason.

Lot's of routers are equipped with linux firmeware these days and as a laptop driver may be affected, as much a router may be the reason too.

There have been some very strange bugs with Linux wifi implementations, where both a faulty router firmware and a faulty laptop firmeware added up to a working combination. As the laptop got a new kernel with _fixed_ WIFI stack, the line ceased working, lost speed, couldn't assign an IP and many other quirks.

Radosław Piliszek (radzio) wrote :

Not in my case. I tried with two different routers.

@kdekda: Try #250 please.

Eric Appleman (erappleman) wrote :

jhoechtl, router doesn't matter trust me. This bug has been seen on cheap routers, expensive routers, old routers, new routers, Ralink routers, Atheros routers, Broadcom routers, etc.

Changed in linux:
importance: Unknown → High
status: Unknown → Confirmed

Jim Gettys posted on some bufferbloat related performance patch for the 3945 which might be relevant.

http://gettys.wordpress.com/2011/02/13/bufferbloat-related-patches-for-the-iwl3945/

Radosław Piliszek (radzio) wrote :

Quoting that page: "with no bandwidth performance difference".
I doubt it could help us.

p4tr1ck (pstedem) wrote :

I removed #245 and tried #250 and had no improvement. Still under 1 Mbps.

Radosław Piliszek (radzio) wrote :

@Patrick: If you're sure you did it properly, it may mean you experience some kind of third version of this bug...

Radosław Piliszek (radzio) wrote :

To sum up, there are at least three *different* bugs resulting in similar behavior:
- PLCP-related (#236, #237, #250 fix it)
- hwscan-related (#250 fixes it - this is in my case)
- still unknown because for some neither of above applies
I'm still waiting for reports on #250.

Andy Whitcroft (apw) wrote :

@Radolslaw -- I believe that the first bug above (PLCP-related) is the one fixed by the commit below, this commit seems to be wending its way to mainline so I would like to get some testing and confirmation that it fixes at least one of these categories of bugs:

  commit c91d01556f52255a31575be0cb1981c92a2a5028
  Author: Stanislaw Gruszka <email address hidden>
  Date: Wed Feb 9 08:46:06 2011 +0100

    iwl3945: remove plcp check

    Patch fixes:
    https://bugzilla.redhat.com/show_bug.cgi?id=654599

    Many users report very low speed problem on 3945 devices,
    this patch fixes problem, but only for some of them.

    For unknown reason, sometimes after hw scanning, device is not able
    to receive frames at high rate. Since plcp health check may request
    hw scan to "reset radio", performance problem start to be observable
    after update kernel to .35, where plcp check was introduced.

    Bug reporter confirmed that removing plcp check fixed problem for him.

    Reported-and-tested-by: SilvioTO <email address hidden>
    Cc: <email address hidden> # 2.6.35+
    Signed-off-by: Stanislaw Gruszka <email address hidden>
    Acked-by: Wey-Yi Guy <email address hidden>
    Signed-off-by: John W. Linville <email address hidden>

I have built some kernels with this patch applied. These are Natty kernels but should function at least on Maverick. If those who are able could confirm whether this fixes this issue for them. I am most interested in those who already found that the fixes in #236, #237, and #250 already fixed them; this is most unlikely to fix you if those did not. If these are successful we can consider this fix for Maverick. Please test and report back here. Kernels are at the URL below:

    http://people.canonical.com/~apw/lp621265-natty/

I will note that clearly (as Radoslaw correctly points out) at least 3 issues here. A bug really only usefully can represent one of these; in part a launchpad limitation, part human. I am therefore nominating this bug to represent the class of issues fixable via the PLCP fix. We will want to split the other two known issues off to separate bugs so we can gather only the symptom data for those specific issues.

Changed in linux (Ubuntu):
status: Confirmed → Incomplete
Changed in linux (Ubuntu Maverick):
importance: High → Medium
Changed in linux (Ubuntu):
importance: Undecided → Medium
nicholas (nicholas-linpro) wrote :

Confirmed, http://people.canonical.com/~apw/lp621265-natty/ fixes the problem for me:

Linux spdy 2.6.38-4-generic #31~lp621265v201102161335 SMP Wed Feb 16 13:37:55 UTC 2011 i686 GNU/Linux
12.38 Mb/s from speedtest.net

vs the maverick kernel:
Linux spdy 2.6.35-25-generic #44-Ubuntu SMP Fri Jan 21 17:40:48 UTC 2011 i686 GNU/Linux
0.69 Mb/s (repeatedly) from speedtest.net

nicholas@spdy:~$ lspci -vnn | grep -A 1 Wireless
03:00.0 Network controller [0280]: Intel Corporation PRO/Wireless 3945ABG [Golan] Network Connection [8086:4227] (rev 02)
 Subsystem: Intel Corporation ThinkPad R60e/X60s [8086:1011]

Radosław Piliszek (radzio) wrote :

@Andy Whitcroft:
Right, splitting it is a must.

I restudied all the posts and came to conclusion that the PLCP check patch helps with devices of at least these three subsystems:
[8086:1011]
[8086:1020]
[8086:1041]

And the hwscan patch (in other words: disable_hw_scan=1 as default and 2.6.38's new swscan method) helps me so it fixes at least:
[8086:1001]

Results for the rest are still unknown.

@kdekda: You have [8086:1021] Could you please try the #264? If it does not help immediately, please try (with the same kernel):
sudo rmmod iwl3945 iwlcore
sudo modprobe iwl3945 disable_hw_scan=1

krader (apictor) wrote :

My card is:

lspci -vnn | grep -A 1 Wireless
05:00.0 Network controller [0280]: Intel Corporation PRO/Wireless 3945ABG [Golan] Network Connection [8086:4222] (rev 02)
 Subsystem: Intel Corporation PRO/Wireless 3945ABG Network Connection [8086:1001]
 Flags: bus master, fast devsel, latency 0, IRQ 29

I've tried to test http://people.canonical.com/~apw/lp621265-natty/ kernel (64bits versio), but my laptop gets freezed when trying to launch the X environment (I check it runnint at failsafe mode, in the menu displayed I selected resume, then logged in into the system and then launch "startx". Then, nothing but a black screen appears, and the only solution is to press power button once and wait the system shut down automaticaly (so the systems works, but something not))

What may be the problem? I've reinstalled Nvidia driver to force DKMS to rebuild the module to check if that was the problem, but didn't helped.

Andy Whitcroft (apw) wrote :

@Radoslaw -- thanks for the information there. I am inclined to commit the fix for the PLCP check against this bug and recommend we start new ones for the other two. Obviously we should link those bugs here for completeness. Once I commit that fix this bug will get auto closed on the next upload.

@nicolas -- thanks for the speedy testing feedback

Radosław Piliszek (radzio) wrote :

@krader: If I'm correct, you may benefit from #250. Use the normal kernel and carefully follow instructions in that archive.

@Andy: Do we have to auto-close it? Would be wise to see which subsystems get fixed by this patch (give it a week more to live).

Andy Whitcroft (apw) wrote :

@krader -- that kernel is an early development kernel and currently the proprietry drivers have not updated to track the upstream updates.

I have pulled this fix back to Maverick kernels to see if it works there. Could those of you on Maverick test the kernel below. Please report back here. The kernels are at the URL below:

    http://people.canonical.com/~apw/lp621265-maverick/

Thanks.

Changed in linux (Ubuntu Maverick):
status: Confirmed → Incomplete
Changed in linux (Ubuntu):
assignee: nobody → Andy Whitcroft (apw)
Changed in linux (Ubuntu Maverick):
assignee: nobody → Andy Whitcroft (apw)
Radosław Piliszek (radzio) wrote :

When posting results of #270:

- state if it fixes your problem
- post the output of "lspci -vnn | grep -A 1 Wireless" (even if you did before)

Thanks.

picomike (picomike) wrote :

#270 seems to fix my problem. I've just downloaded a 1,2GB file at full speed and the output at speedtest.net is perfectly normal, as good as on Lucid.

miguel@GoldorakLap:~$ lspci -vnn | grep -A 1 Wireless
05:00.0 Network controller [0280]: Intel Corporation PRO/Wireless 3945ABG [Golan] Network Connection [8086:4222] (rev 02)
 Subsystem: Intel Corporation PRO/Wireless 3945ABG Network Connection [8086:1001]
 Flags: bus master, fast devsel, latency 0, IRQ 45

Jordy Potman (jordypotman) wrote :

#270 also seems to fix the problem for me. Before #270 I used the kernel from #237 which also fixed the problem for me. The standard Maverick kernel (Linux laptop 2.6.35-25-generic #44-Ubuntu SMP Fri Jan 21 17:40:48 UTC 2011 i686 GNU/Linux) gave me sometimes very bad numbers on speedtest.net .

$ lspci -vnn | grep -A 1 Wireless
0b:00.0 Network controller [0280]: Intel Corporation PRO/Wireless 3945ABG [Golan] Network Connection [8086:4222] (rev 02)
 Subsystem: Intel Corporation Device [8086:1021]
$ uname -a
Linux laptop 2.6.35-27-generic #47lp621265v201102161837 SMP Wed Feb 16 18:40:53 UTC 2011 i686 GNU/Linux

Nicolas Albert (nicoa380) wrote :

I installed kernel from http://people.canonical.com/~apw/lp621265-maverick/ too (i386) and it clearly better.

With speedtest.net :
 * 8 Mb/s using WiFi with this kernel
 * 10 Mb/s using Ethernet (as well as WiFi on my HTC Desire)

krader (apictor) wrote :

#270 seems to work well for now. Will test it for more days, but it downladed 2GB at almost full speed.

$ lspci -vnn | grep -A 1 Wireless
05:00.0 Network controller [0280]: Intel Corporation PRO/Wireless 3945ABG [Golan] Network Connection [8086:4222] (rev 02)
 Subsystem: Intel Corporation PRO/Wireless 3945ABG Network Connection [8086:1001]
 Flags: bus master, fast devsel, latency 0, IRQ 45

$ uname -r
2.6.35-27-generic

Eric Appleman (erappleman) wrote :

The new test Maverick and Natty kernels look promising.

iwl3945: 12/12 average
ndiswrapper: 12/12 average

The real test is whether this can be replicated over the course of hours and ISO download stress tests.

p4tr1ck (pstedem) wrote :

The #270 kernel is working well for me. I'm back up to Lucid kernel speeds.

lspci -vnn | grep -A 1 Wireless
03:00.0 Network controller [0280]: Intel Corporation PRO/Wireless 3945ABG [Golan] Network Connection [8086:4227] (rev 02)
 Subsystem: Intel Corporation Device [8086:1010]

#270 works well for me.

0c:00.0 Network controller [0280]: Intel Corporation PRO/Wireless 3945ABG [Golan] Network Connection [8086:4222] (rev 02)
 Subsystem: Intel Corporation Device [8086:1020]

#270 works for me also.

Network controller: Intel Corporation PRO/Wireless 3945ABG [Golan] Network Connection (rev 02)

Guntbert Reiter (guntbert) wrote :

#270 works completely satisfying here, I get sustained 15.8 Mb/s with only now and then dropping to 400 kb/s for several seconds.

$ lspci -vnn |grep -A 1 Wire
03:00.0 Network controller [0280]: Intel Corporation PRO/Wireless 3945ABG [Golan] Network Connection [8086:4227] (rev 02)
 Subsystem: Intel Corporation ThinkPad R60e/X60s [8086:1011]

Espen (espenbe) wrote :

I downloaded the kernels from #270 and experienced a significantly increased download speed. Now I get about the same download speed as I do with the MacBookPro. Very promising! So far about 1GB of an ISO-image is downloaded. Sometimes the speed drops to <100KB/sec, but it gaines the speed after a few seconds. I can surely live with that.

Thank you Andy and you other devs working on this issue. This is (in my opinion) a major step forward!

Output from lspci:
espenbe@ministerial:~$ lspci -vnn |grep -A 1 Wireless
0c:00.0 Network controller [0280]: Intel Corporation PRO/Wireless 3945ABG [Golan] Network Connection [8086:4222] (rev 02)
 Subsystem: Intel Corporation Device [8086:1021]

I have been following this for some time and with the great improvements I have been reading I thought it was finally time to give it a try.

I too downloaded the kernel from #270 and experienced no change in download speed.

$ lspci -vnn |grep -A 1 Wireless
06:00.0 Network controller [0280]: Intel Corporation PRO/Wireless 3945ABG [Golan] Network Connection [8086:4222] (rev 02)
 Subsystem: Intel Corporation PRO/Wireless 3945ABG Network Connection [8086:1000]
 Flags: bus master, fast devsel, latency 0, IRQ 44
$ uname -a
Linux billlaptop 2.6.35-27-generic #47lp621265v201102161837 SMP Wed Feb 16 18:40:53 UTC 2011 i686 GNU/Linux

BandwidthPlace.com:
   Download Speed: 1178 kbps (147.3 KB/sec transfer rate)
   Upload Speed: 641 kbps (80.1 KB/sec transfer rate)
   Thu 17 Feb 2011 10:42:17 PM CST

Radosław Piliszek (radzio) wrote :

krader and picomike have the same revision as I do but this fix helps them. Therefore subsystem may be of no importance.

However, William Scheidegger shares my experience and this fix doesn't help him.

@William Scheidegger: Could you please try:

sudo rmmod iwl3945 iwlcore
sudo modprobe iwl3945 disable_hw_scan=1

with this new kernel and report back?

Thanks.

Radosław Piliszek (radzio) wrote :

About #283:
Don't try this with #270, it is meant to work with #250. My bad. Sorry.

It fixes my issue, so it's worth a try.

kdekda (teabof) wrote :

lspci -vnn | grep -A 1 Wireless:
0c:00.0 Network controller [0280]: Intel Corporation PRO/Wireless 3945ABG [Golan] Network Connection [8086:4222] (rev 02)
        Subsystem: Intel Corporation Device [8086:1021]
#250
seems to work well for now..speed is about 600KB/s, almost like in windows.
#264 and #270
these kernels can't boot, plymouth freezes..i'll try to resolve this issue and test the speed

Mtt.Castelli (mtt.castelli) wrote :

#270 make some good improvement for me. I can't say it solved the problem, but now we can live.

$ lspci -vnn | grep -A 1 Wireless
0c:00.0 Network controller [0280]: Intel Corporation PRO/Wireless 3945ABG [Golan] Network Connection [8086:4222] (rev 02)
 Subsystem: Intel Corporation Device [8086:1021]

thanks, Andy.

Radosław Piliszek (radzio) wrote :

@kdekda: #250 is the one which includes the fix I needed (new swscan algo and hwscan disabled by default).
As previous kernel didn't help you, it seems you experience the same problem I did.
Undoubtedly, at least 2 different bugs right here with optional third but let's still wait for the results.

@Radosław

I appologize for the length of this post, but I am trying to be as thorough as possible.

After the installation and before my post last night I had rebooted my machine.

After my post, I continued searching the forums and installed the Ubuntu "linux-backports-modules-compat-wireless-2.6.37-maverick-generic" package and received similar results.
I left my machine powered and attached to my home network today. Before I read your request I ran a test and received:
   Download Speed: 5092 kbps (636.5 KB/sec transfer rate)
   Upload Speed: 624 kbps (78 KB/sec transfer rate)
   Fri 18 Feb 2011 09:08:25 PM CST

This is comparable to my wife's M$ machine.

After I read the post I went ahead and followed the instructions and received:
   Download Speed: 5010 kbps (626.3 KB/sec transfer rate)
   Upload Speed: 623 kbps (77.9 KB/sec transfer rate)
   Fri 18 Feb 2011 09:10:42 PM CST

This appears to have had no change as it was already at the expected rate.

Just to make sure, I rebooted the machine and received:
   Download Speed: 1132 kbps (141.5 KB/sec transfer rate)
   Upload Speed: 622 kbps (77.8 KB/sec transfer rate)
   Fri 18 Feb 2011 09:35:26 PM CST

I performed your procedure (i.e. rmmod followed by the modprobe) and received an initial result from SpeedTest.net of:
   2011-02-18 9:39 PM CST 5.22 Mb/s 0.63 Mb/s 35 ms

I performed another one with BandwidthPlace.com and received:
   Download Speed: 1127 kbps (140.9 KB/sec transfer rate)
   Upload Speed: 634 kbps (79.3 KB/sec transfer rate)
   Fri 18 Feb 2011 09:42:07 PM CST

Just to make sure it wasn't a fluke, I ran SpeedTest.net again and recieved:
   2011-02-18 9:40 PM CST 1.18 Mb/s 0.63 Mb/s 36 ms

I will leave my machine up tonight and see what I get in the morning. Is there any other logs or commands that would help in troubleshooting this problem? I am also a Software Engineer, but usually work on embedded stuff and have never actually delved into the inner workings of the Linux kernel or drivers. I am willing to start, but it may be slow getting me up to speed and productive.

Do I need to remove the "linux-backports-modules-compat-wireless-2.6.37-maverick-generic" package before continuing or does it have any effect with the new kernel?

$ lspci -vnn |grep -A 1 Wireless
06:00.0 Network controller [0280]: Intel Corporation PRO/Wireless 3945ABG [Golan] Network Connection [8086:4222] (rev 02)
 Subsystem: Intel Corporation PRO/Wireless 3945ABG Network Connection [8086:1000]
 Flags: bus master, fast devsel, latency 0, IRQ 44
$ uname -a
Linux billlaptop 2.6.35-27-generic #47lp621265v201102161837 SMP Wed Feb 16 18:40:53 UTC 2011 i686 GNU/Linux

Just to test it out, I removed the "linux-backports-modules-compat-wireless-2.6.37-maverick-generic" package and performed the rmmod/modprobe again. An immediate test resulted in:
   Download Speed: 4282 kbps (535.3 KB/sec transfer rate)
   Upload Speed: 624 kbps (78 KB/sec transfer rate)
   Fri 18 Feb 2011 10:14:42 PM CST

A subsequent test resulted in:
   Download Speed: 1139 kbps (142.4 KB/sec transfer rate)
   Upload Speed: 626 kbps (78.3 KB/sec transfer rate)
   Fri 18 Feb 2011 10:16:14 PM CST

I just performed the rmmod/modprobe again and received:
   Download Speed: 1150 kbps (143.8 KB/sec transfer rate)
   Upload Speed: 624 kbps (78 KB/sec transfer rate)
   Fri 18 Feb 2011 10:45:51 PM CST

Attached is a snippet of the file created with: while true;do sudo dmesg -c >> /tmp/dmesg.log; sleep 3; done

Radosław Piliszek (radzio) wrote :

Yup, you have to remove compat-wireless.
Anyway, the rmmod and modprobe works fine only with 2.6.38's wireless stack.
Moreover, it's not needed with #250, because it will default to swscan.

Should #250 and #270 be considered to be mutually exclusive, compatible, or conjunctive?

Radosław Piliszek (radzio) wrote :

If you installed #270 and now apply #250, it will work fine.

I know these are newbie questions and I thank you for your help and patience.

Previously I had installed only the linux-image-xxx.deb from #270. When I tried to build #250, of course it errored out without the headers. When I tried to install the linux-headers-xxx.deb from #270, I received the following:

$ sudo dpkg -i linux-headers-2.6.35-27-generic_2.6.35-27.47lp621265v201102161837_i386.deb
Selecting previously deselected package linux-headers-2.6.35-27-generic.
(Reading database ... 412950 files and directories currently installed.)
Unpacking linux-headers-2.6.35-27-generic (from linux-headers-2.6.35-27-generic_2.6.35-27.47lp621265v201102161837_i386.deb) ...
dpkg: dependency problems prevent configuration of linux-headers-2.6.35-27-generic:
 linux-headers-2.6.35-27-generic depends on linux-headers-2.6.35-27; however:
  Package linux-headers-2.6.35-27 is not installed.
dpkg: error processing linux-headers-2.6.35-27-generic (--install):
 dependency problems - leaving unconfigured
Errors were encountered while processing:
 linux-headers-2.6.35-27-generic

I am assuming that I am just missing a repository reference that is not active by default. I have been searching around to find which one I am missing, but all I could find was a reference to the raw unpackaged source for it at:

   https://launchpad.net/ubuntu/maverick/+source/linux/2.6.35-27.47

Any thoughts?
Thanks again for all the assistance in this matter.

s0undt3ch (ufs) wrote :

lspci -vnn | grep -A 1 Wireless

05:00.0 Network controller [0280]: Intel Corporation PRO/Wireless 3945ABG [Golan] Network Connection [8086:4222] (rev 02)
        Subsystem: Intel Corporation PRO/Wireless 3945ABG Network Connection [8086:1001]
        Flags: bus master, fast devsel, latency 0, IRQ 46

uname -a
Linux lgl 2.6.35-27-generic #47lp621265v201102161837 SMP Wed Feb 16 18:40:53 UTC 2011 i686 GNU/Linux

Speedtest.net reports:
  12.95 Mb/s Download
  1.52 Mb/s Upload
  12ms ping

Currently Moving a 5,4Gig folder at about 900KiB-1,3Mib/s. Currently at 500Mib....

Seems to be stable, I'll report if I get into trouble again.

As I mentioned earlier, I have been a linux distro user for years, but have never had to delve into the building of individual kernel modules. So I thought I would post this lesson of what NOT to do.

<START LESSON>

I followed the README instructions and issued the commands below:
   $ ./scripts/driver-select iwlwifi
   $ make
   $ sudo make install
   $ sudo make wlunload
   $ sudo modprobe iwl3945

and on the modprobe I received:
   FATAL: Error inserting iwl3945 (/lib/modules/2.6.35-27-generic/kernel/drivers/net/wireless/iwlwifi/iwl3945.ko): Invalid argument

with the end of my dmesg log showing several:
   iwlcore: disagrees about version of symbol <SYMBOL_NAME>
   iwlcore: Unknown symbol <SYMBOL_NAME> (err -22)

Thinking that I may have not uninstalled enough kernel modules before trying to install the new iwl3945, I rebooted the machine. When the machine was back up, I had the exact same messages the dmesg log.

I was able to get back to the my original (i.e. slow) state by issuing:
   $ sudo make wlunload
   $ sudo modprobe iwl3945

<STOP LESSON>

The first step in the lesson above, driver-select, is a shortcut and sped up the compile and install times dramatically. As I was investigating this problem, I found that this shortcut does not build the mac80211 module and the "disagrees about version of symbol" errors are due to the original mac80211 module not being compatible with the new iwlcore and iwl3945 modules.

The correct steps are below:
   $ ./scripts/driver-select restore
   $ make
   $ sudo make install
   $ sudo make wlunload
   $ sudo modprobe iwl3945

I now have a fully functional iwl3945 module loaded and consistently getting speeds comparable to my wife's M$ machine.

5.14 Mb/s Download
0.65 Mb/s Upload
35 ms Ping

Everything seems to be stable.

@Andy Whitcroft Thanks for the work on getting this fixed.
@Radosław Piliszek Thanks for the patience and guidance.
@s0undt3ch Thanks again for the assistance.

Just for completeness below is the output from lspci and uname:
   $ lspci -vnn | grep -A 1 Wireless
      06:00.0 Network controller [0280]: Intel Corporation PRO/Wireless 3945ABG [Golan] Network Connection [8086:4222] (rev 02)
         Subsystem: Intel Corporation PRO/Wireless 3945ABG Network Connection [8086:1000]
         Flags: bus master, fast devsel, latency 0, IRQ 47
   $ uname -a
      Linux billlaptop 2.6.35-27-generic #47lp621265v201102161837 SMP Wed Feb 16 18:40:53 UTC 2011 i686 GNU/Linux

I also noticed that I was the only one reporting on the Subsystem [8086:1000].

data (data) wrote :

I installed #270 and it does not work yet. Speed still drops down to <150KiB/s

sudo lspci -vnn | grep -A 1 Wireless
0b:00.0 Network controller [0280]: Intel Corporation PRO/Wireless 3945ABG [Golan] Network Connection [8086:4222] (rev 02)
 Subsystem: Intel Corporation Device [8086:1021]

s0undt3ch (ufs) wrote :

After moving the folder without problems on #295 I went to bed and left the laptop on. About 10 to 12 hours later I get to the laptop, net responsiveness is shitty, so is the speed, I tried to reconnect without any luck at all. So I guess my problem is not yet solved. Oh forgot to tell, the move was from an nfs mount, if that makes any difference.

Should I also compile and install the module as done in #298 too?

Radosław Piliszek (radzio) wrote :

@data, @s0undt3ch: Please try #250, great instructions are in #298.

@William Scheidegger: I think credits for #250 should go to Stanislaw Gruszka from Redhat.

@Radosław: I wasn't trying to slight anyone, so kudos out to Stanislaw Gruszka from Redhat also.

I have to second s0undt3ch on this. After leaving my machine on all day yesterday and today, when I got home tonight my connectivity is back to slow again. I will try removing #250 and rebooting, but that sounds like where s0undt3ch is.

With #250 installed, my system is better, at least there is a minute or two of decent bandwidth. After the rmmod/modprobe below, I ran back to back BandwidthPlace.com tests:

   sudo rmmod iwl3945 iwlcore mac80211 cfg80211
   sudo modprobe iwl3945

and received:

   Download Speed: 4595 kbps (574.4 KB/sec transfer rate)
   Upload Speed: 631 kbps (78.9 KB/sec transfer rate)
   Mon 21 Feb 2011 09:04:54 PM CST

   Download Speed: 1169 kbps (146.1 KB/sec transfer rate)
   Upload Speed: 626 kbps (78.3 KB/sec transfer rate)
   Mon 21 Feb 2011 09:05:36 PM CST

These are documented in the attachment.

I also had my wife run the test on her M$ machine followed by my machine. This is documented in the attachment.

I also performed the rmmod/modprobe followed by the wget below.

   sudo rmmod iwl3945 iwlcore mac80211 cfg80211
   sudo modprobe iwl3945
   wget -b http://mirror.anl.gov/pub/ubuntu-iso/CDs-Ubuntu/10.10/ubuntu-10.10-desktop-i386.iso

The snippet from attached wget-log.txt that points out the slowdown is:

  1600K .......... .......... .......... .......... .......... 0% 315K 36m56s
  1650K .......... .......... .......... .......... .......... 0% 405K 36m42s
  1700K .......... .......... .......... .......... .......... 0% 158K 37m47s
  1750K .......... .......... .......... .......... .......... 0% 124K 39m22s

I stopped the download at the 1% mark as it didn't change significantly.

Disregarding the initial speedup provided by the rmmod/modprobe, my machine consistently has a download speed of around 1000 kbps.

thsundel (thsundel) wrote :

Finally, thanks for the FIX and for the instructions. I can confirm that this patch provided from Redhat significantly improves the speed with my Intel 3945 wireless.

Before I got about 240 kb/s and after applying the patch I get 1400 kb/s (about same speed as with Windows), it sometimes drop to about 400 kb/s but that could be caused by the ftp server I downloaded a ISO from during my testing.

I'm so happy, thank you very very much. Would it be possible to get this patch to upstream?

s0undt3ch (ufs) wrote :

$ lspci -vnn | grep -A 1 Wireless
05:00.0 Network controller [0280]: Intel Corporation PRO/Wireless 3945ABG [Golan] Network Connection [8086:4222] (rev 02)
        Subsystem: Intel Corporation PRO/Wireless 3945ABG Network Connection [8086:1001]
        Flags: bus master, fast devsel, latency 0, IRQ 46

$ uname -a
Linux lgl 2.6.35-27-generic #47lp621265v201102161837 SMP Wed Feb 16 18:40:53 UTC 2011 i686 GNU/Linux

I downloaded an empty file with 256MB, ie, "dd if=/dev/zero of=250MB.empty bs=1k count=250000", for each of the tests.

From Lan:
Wget'ing a 256Mb file logfile: 256MB.empty.lan.log
No speedtest.net stats here since this is a headless server, and it's also a debian distro not ubuntu, but done just for the sake of lan speed stats.

Distro module:
Wget'ing a 256Mb file logfile: 256MB.empty.distro.log

Speedtest.net reports:
8.85 Mb/s Download
1.56 Mb/s Upload
16ms Ping.

Compat module:
Wget'ing a 256Mb file logfile: 256MB.empty.compat.log

Speedtest.net reports:
6.20 Mb/s Download
1.56 Mb/s Upload
15ms Ping.

s0undt3ch (ufs) wrote :
s0undt3ch (ufs) wrote :
s0undt3ch (ufs) wrote :
Espen (espenbe) wrote :

I have now used #270 for 6 days, and I still get about 7Mbit/s down and 0.64Mbit/s up. These number are what I could expect from my ISP. I get the same speed by testing the from my MacBookPro.

#270 surely works for my system and I am very happy!

espenbe@ministerial:~$ uname -a
Linux ministerial 2.6.38-4-generic #31~lp621265v201102161335 SMP Wed Feb 16 13:37:55 UTC 2011 i686 GNU/Linux

espenbe@ministerial:~$ lspci -vnn | grep -A 1 Wireless
0c:00.0 Network controller [0280]: Intel Corporation PRO/Wireless 3945ABG [Golan] Network Connection [8086:4222] (rev 02)
 Subsystem: Intel Corporation Device [8086:1021]

s0undt3ch (ufs) wrote :

I seem to be getting lower performance from the compat driver then from the #270 kernel alone. Leaving computer on to see it although performance seems worse the connection keeps stable unlike what happened with the new kernel alone. Any other suggestions?

krader (apictor) wrote :

When something get fixed, something can be broken. I've realised today that with #270 kernel, my laptop can't be suspended, it just get hanged and the only solution is to power off laptop by releasing battery or by long-pressing the power button (it does not respond, the only thing I see is the processor fan runs at max power, so I think the processor is 100% used for nothing)

Eric Appleman (erappleman) wrote :

Andy, what information is still needed to get this bug from Incomplete to the Ubuntu kernel?

Nandan Vaidya (gotunandan) wrote :

Just thought I'd post my experience with this bug and testing out the potential fix.

I have the following configuration:

nandan@nandan-Aspire-5920:~$ lspci -vnn | grep -A 1 Wireless
06:00.0 Network controller [0280]: Intel Corporation PRO/Wireless 3945ABG [Golan] Network Connection [8086:4222] (rev 02)
 Subsystem: Intel Corporation PRO/Wireless 3945ABG Network Connection [8086:1000]
 Flags: bus master, fast devsel, latency 0, IRQ 43
nandan@nandan-Aspire-5920:~$ uname -a
Linux nandan-Aspire-5920 2.6.35-27-generic #47lp621265v201102161837 SMP Wed Feb 16 18:51:57 UTC 2011 x86_64 GNU/Linux

I did not compile the module provided by the Red Hat folks but only applied the kernel provided by Andy.

When using the 2.6.35-27 kernel , my speeds are back to normal, which is actually 1Mbps itself, since it is capped by the ISP :|
Prior to that my speeds were less than 1Mbps, closer to 512kbps, so there is some improvement from the earlier regression.

Unfortunately, I cannot test whether it does or doesnt go any faster than that at the moment, since my wifi at home is capped at 1Mbps :(

P.S. The subsystem on my 3965 wireless chip is [8086:1000] as well.
And I remember seeing a message like "Failed to initiate AccessPoint scan" in /var/log/syslog when using the default Maverick kernels. This message seems to be gone using the 2.6.35-27 kernel

enedene (enedene) wrote :

uname -a
Linux mylaptop 2.6.35-25-generic #44-Ubuntu SMP Fri Jan 21 17:40:48 UTC 2011 i686 GNU/Linux

lspci -vnn | grep -A 1 Wireless
03:00.0 Network controller [0280]: Intel Corporation PRO/Wireless 3945ABG [Golan] Network Connection [8086:4222] (rev 02)
 Subsystem: Intel Corporation PRO/Wireless 3945ABG Network Connection [8086:1001]

Here is my problem, when I start computer it runs ok for a short period of time, and then the connection drops to about 100kbs, it works stable but it never goes up. I'm having this issue for a couple of releases, and I can't remember if I had it before that.

Radosław Piliszek (radzio) wrote :

@enedene: You must have the same problem I do! Try #250. It helps me.

Radosław Piliszek (radzio) wrote :

As they were obsoleted, I deleted #236's and #237's patched kernels from my site.

Nandan Vaidya (gotunandan) wrote :

So a security update for the kernel has arrived on Maverick which is linux-image-generic-2.6.35-27.48

I have the 2.6.35-27 kernel posted in #270 . Correct me if wrong, but I do not think those changes have been integrated in the update.

Since it is a security fix, not a standard bug fix update, and the USN mentions several security fixes , I am really unsure of what to do.
Normally I would always install the security updates, but in this case ?

Changed in linux (Ubuntu):
status: Incomplete → Confirmed

I just updated to the latest Ubuntu kernel and had the same slow connection. I then went and downloaded the latest compat-wireless source from:

http://wireless.kernel.org/download/compat-wireless-2.6/compat-wireless-2011-03-03.tar.bz2

After following the same rough instructions I posted in #298, I am now happy to report that all has been running stably with good download speeds for over an hour.

--- From http://www.bandwidthplace.com/
   Download Speed: 5084 kbps (635.5 KB/sec transfer rate)
   Upload Speed: 643 kbps (80.4 KB/sec transfer rate)
   Fri 04 Mar 2011 12:24:12 AM CST

This is comparable to my wife's M$ machine. I didn't go through the history to determine if it was the kernel or drivers, but I am back in a truly working state for now.

I will post back if anything changes.

$ lspci -vnn | grep -A 1 Wireless
06:00.0 Network controller [0280]: Intel Corporation PRO/Wireless 3945ABG [Golan] Network Connection [8086:4222] (rev 02)
 Subsystem: Intel Corporation PRO/Wireless 3945ABG Network Connection [8086:1000]
 Flags: bus master, fast devsel, latency 0, IRQ 45

$ uname -a
Linux billlaptop 2.6.35-27-generic-pae #48-Ubuntu SMP Tue Feb 22 21:46:58 UTC 2011 i686 GNU/Linux

Just to update this after, my speeds are still stable several days of continuous operation.

CarlosRuiz_globalqss (carg67) wrote :

William, thanks for your suggestion, they were useful for me.

I have a doubt, instead of following your advice to download compat-wireless-2011-03-03.tar.bz2 I executed:

sudo apt-get install linux-backports-modules-compat-wireless-2.6.36-maverick-generic

Is that a similar solution? It raised the stability of the connection, and practically duplicated the download speed, but still doesn't reach the whole bandwidth potential (wondering if this time is because of wifi noise).

Regards,

Carlos Ruiz

@CarlosRuiz_globalqss This is deffinately a similar solution. If you are still not noticing speeds that you would expect, there are several reasons that could be causing it. I was batteling my WAN connection during testing, so I always had to double check with a machine running a different OS.

If you are sure your connection is good, both the WAN and WI-FI, then you may have just found that it is a driver difference between that available with the linux-backports-modules-compat-wireless-2.6.36-maverick-generic and where the current stable line is directly from wireless.kernel.org.

Guntbert Reiter (guntbert) wrote :

report: I tried both #323 and #321
#323 improved but not by much
#321 restored the throughput to the "old" values, but with much longer and deeper drops than #270, so I reverted to #270 again and choose to ignore the security patch for now.
------
03:00.0 Network controller [0280]: Intel Corporation PRO/Wireless 3945ABG [Golan] Network Connection [8086:4227] (rev 02)
 Subsystem: Intel Corporation ThinkPad R60e/X60s [8086:1011]

Mtt.Castelli (mtt.castelli) wrote :

@Andy Whitcroft and others

Today I did some security-update, among which kernel 2.6.35-27 that overwrite the #270 one. So the problem is back.
We can't hold disabled security update, so we could block that packages, but maybe you could also upload a new kernel...

please. M

s0undt3ch (ufs) wrote :

Ever since I updated to latest security update I couldn't use the wireless compat modules from http://wireless.kernel.org/. So, with the regular modules, If I watch a video from an NFS mount on my network, I'll loose the wireless connection. I have to disable and then re-enable wireless to gain a working connection again just to loose it in a minute or two. Same happens with the linux-backports-modules-compat-wireless-2.6.36-maverick-generic.

As a workaround I add "radeon.modeset=0" the the kernel I'm loading on grub. That makes the connection pretty dam stable, so far no wireless connection lost, event watching that video from the NFS mount.

$ lspci -vnn | grep -A 1 Wireless
05:00.0 Network controller [0280]: Intel Corporation PRO/Wireless 3945ABG [Golan] Network Connection [8086:4222] (rev 02)
        Subsystem: Intel Corporation PRO/Wireless 3945ABG Network Connection [8086:1001]
        Flags: bus master, fast devsel, latency 0, IRQ 45

$ uname -a
Linux lgl 2.6.35-27-generic-pae #48-Ubuntu SMP Tue Feb 22 21:46:58 UTC 2011 i686 GNU/Linux

Torsten Krah (tkrah) wrote :

@s0undt3ch:

Are you sure with your workaround "radeon.modeset=0" for this bug?
I mean - thats a kms radeon switch - graphic stuff - not a wireless one - and this really helps?

s0undt3ch (ufs) wrote :

@ Torsten Krah

I don't remember where I previously saw this, but I had this issue before maverick and back then the info available stated that it was some IRQ issue between the graphics and the wireless card, the intel wireless card being the culprit.

So previously I hardcoded that switch in grub for every kernel to load, we DO loose the nice boot graphics but that's apparently it. Connection remains stable and so do the speeds.

Just now I did a speedtest.net test:

  Ping : 16ms
  Up : 19.07 Mbps
  Down: 1.56 Mbps

Without hardcoding you can try it yourself, on your grub loader hit "e" which will edit the current entry. At the end of the line add what I said previously, then hit CTRL-X to load that entry and test your wireless connection to exhaustion.

Do note that using the maverick kernel provided here and the compat drivers also provided here, before the security kernel got released, I was also having similar good results. So, what's the actual fix? Duno :| Just know that what I'm doin' works...

Torsten Krah (tkrah) wrote :

I don't have a radeon but a nvidia card using nouveau - yes i can disable kms there too - but it does not fix this bug, at least it does not do this for me.

s0undt3ch (ufs) wrote :

Yeah, forgot to say that I had an ATI, which would lead you to the conclusion you just reached...

Roman (vik-atacomp) wrote :

DELL D620, the same bug for a long time..

Maybe another thing, can be in touch with this bug, I usually don't turn off the laptop, I use suspend to RAM.
But occasionally, randomly, once in 3-4 tries, the wifi after wake-up is not able to get IP or to login,
I use WPA, mixed a/b/g.

So I don't know if it's caused by wrong driver/kernel module, but it happends with Intel WiFi card..

I can confirm that installing the kernel here (now obsolete):

http://people.canonical.com/~apw/lp621265-maverick/

 - fixed the problem on a Fujitsu-Siemens V5545 having an Intel Wireless 3945ABG chipset.

No other solutions posted above worked for me.

I just updated to the latest Ubuntu kernel and had the same slow connection again.

--- From http://www.bandwidthplace.com/
    Download Speed: 1149 kbps (143.6 KB/sec transfer rate)
    Upload Speed: 637 kbps (79.6 KB/sec transfer rate)
    Sat 19 Mar 2011 10:02:36 AM CST

I downloaded the latest compat-wireless source from:

    http://wireless.kernel.org/download/compat-wireless-2.6/compat-wireless-2011-03-18.tar.bz2

and followed the same rough instructions I posted in #298:

    $ tar -xjvf compat-wireless-2011-03-18.tar.bz2
    $ cd compat-wireless-2011-03-18
    $ ./scripts/driver-select restore
    $ make
    $ sudo make install
    $ sudo make wlunload
    $ sudo modprobe iwl3945

I am happy to report that all is running stably with good download speeds again.

--- From http://www.bandwidthplace.com/
    Download Speed: 5090 kbps (636.3 KB/sec transfer rate)
    Upload Speed: 640 kbps (80 KB/sec transfer rate)
    Sat 19 Mar 2011 10:56:21 AM CST

$ lspci -vnn | grep -A 1 Wireless
06:00.0 Network controller [0280]: Intel Corporation PRO/Wireless 3945ABG [Golan] Network Connection [8086:4222] (rev 02)
 Subsystem: Intel Corporation PRO/Wireless 3945ABG Network Connection [8086:1000]
 Flags: bus master, fast devsel, latency 0, IRQ 44

$ uname -a
Linux billlaptop 2.6.35-28-generic-pae #49-Ubuntu SMP Tue Mar 1 14:58:06 UTC 2011 i686 GNU/Linux

Nandan Vaidya (gotunandan) wrote :

I can confirm that the instructions mentioned by William Scheidegger (thanks a lot !!!) in post #334 work after updating the kernel to 2.6.35-28.

$ lspci -vnn | grep -A 1 Wireless
06:00.0 Network controller [0280]: Intel Corporation PRO/Wireless 3945ABG [Golan] Network Connection [8086:4222] (rev 02)
 Subsystem: Intel Corporation PRO/Wireless 3945ABG Network Connection [8086:1000]
 Flags: bus master, fast devsel, latency 0, IRQ 44

$ uname -a
Linux nandan-Aspire-5920 2.6.35-28-generic #49-Ubuntu SMP Tue Mar 1 14:39:03 UTC 2011 x86_64 GNU/Linux

-----------------------------------
On the other hand, just using the "linux-backports-modules-compat-wireless-2.6.37-2.6.35-28-generic" package did improve the download speeds at all.

Therefore I had to compile and install the latest compat-wireless drivers from :
http://wireless.kernel.org/download/compat-wireless-2.6/compat-wireless-2011-03-26.tar.bz2

picomike (picomike) wrote :

#334 is working for me too. Finally, I don't have to choose between security and net speed.

Thanks, William :)

$ lspci -vnn | grep -A 1 Wireless
05:00.0 Network controller [0280]: Intel Corporation PRO/Wireless 3945ABG [Golan] Network Connection [8086:4222] (rev 02)
 Subsystem: Intel Corporation PRO/Wireless 3945ABG Network Connection [8086:1001]
 Flags: bus master, fast devsel, latency 0, IRQ 46

$ uname -a
Linux Aspire-5610 2.6.35-28-generic #49-Ubuntu SMP Tue Mar 1 14:40:58 UTC 2011 i686 GNU/Linux

Mtt.Castelli (mtt.castelli) wrote :

Hi, I did a try to the new 2.6.38.2 kernel from here

http://kernel.ubuntu.com/~kernel-ppa/mainline/v2.6.38.2-natty/

and it also seem to solve the problem. So I'm going to handle it for some more hours, and than remove and --purge the patched kernel version from #270.
By the way, because the next ubuntu release is going to use kernel series 2.6.38.x, I imagine this bug will be solved in an
dist-update . I wish...

matteo@Panurge:~$ lspci -vnn | grep -A 1 Wireless
0c:00.0 Network controller [0280]: Intel Corporation PRO/Wireless 3945ABG [Golan] Network Connection [8086:4222] (rev 02)
 Subsystem: Intel Corporation Device [8086:1021]
matteo@Panurge:~$ uname -a
Linux Panurge 2.6.38-02063802-generic #201103281246 SMP Mon Mar 28 12:50:24 UTC 2011 x86_64 GNU/Linux

Radosław Piliszek (radzio) wrote :

@Castelli: Surely it will. Moreover, .38 provides workaround for my bug (effective disabling of hardware scanning).

Goalie Fight (goaliefight) wrote :

Still broken out of the box in the 11.04 release. Disappointing.

$ uname -a
Linux ubuntu 2.6.38-8-generic #42-Ubuntu SMP Mon Apr 11 03:31:50 UTC 2011 i686 i686 i386 GNU/Linux

$ lspci -vnn | grep -i wifi
0c:00.0 Network controller [0280]: Intel Corporation Ultimate N WiFi Link 5300 [8086:4235]

Radosław Piliszek (radzio) wrote :

@Goalie: Ekhm, this bug is about 3945, not 5300.

Albert Pool (albertpool) wrote :

In both Maverick and Natty I can use this card with the full 4 Mbps (500 KB/s) of my connection.

Jan Frybort (jan.frybort) wrote :

This bug started to affect me after a recent kernel upgrade in 11.04 from 2.6.38-8 to 2.6.38-10. If I boot with the previous kernel version, the performance is normal again.

I upgraded to 2.6.38-10 the day it came out and I didn't have any trouble with it. Last night I did a BIOS update on my Acer Aspire 5920 and then this resurfaced. I can also confirm that by backing out to 2.6.38-8 also works for me.

Upon reading the release notes, there seems to have been several things done in the BIOS for my machine regarding the WLAN between the original shipping one and the latest one which I just installed.

Since the BIOS updates for this system require a functioning M$ Vista OS to install them, switching them out is a bit of a pain. If there is any benefit in it, I will do what I can. I am ready to assist in troubleshooting this, but I am not familiar enough with the inner workings of Linux to know where to start.

I am going to try some simple swaptronics by building and installing the latest compat-wireless to see what I get. Pass along any other ideas.

I can confirm finding from Jan Frybort on commtent 342.

$ lspci | grep 3945
04:00.0 Network controller: Intel Corporation PRO/Wireless 3945ABG [Golan] Network Connection (rev 02)

With .38-8 i have internet download speed around 240 kbyte/s, with .38-10 max 40 kbyte/s.

See attached a kern.log from /var/log, showing both boots with .38-8 and .38-10.

Note the new log line "iwl3945 0000:04:00.0: Error setting Tx power (-5)." that is only showing up in.38-10 boot.

You may ignore the brouhaha related to psmouse.c/iwl3945 restarting further down in the log, this is entirely not related to the issue, it does only occur when running the game "osmos" on this system, so different bug, this issue "iwl3945 is slow" occurs also unrelated to the issue "running osmos kills the system".

Regards, Gruessle
Simon

picomike (picomike) wrote :

This bug is back in Natty with 2.6.38-10. I can confirm it too.

JohanF (lurch81) wrote :

Confirming the bug has returned in 2.6.38-10 (download speed 1Mbit/0.1MB per sec).
Reverting to 2.6.38-9 kernel restores full Wifi speed (download speed 20Mbit/2MB per sec).

Skilly (michael-scheepers) wrote :

On 24 July 2011 08:10, JohanF <email address hidden> wrote:

> Confirming the bug has returned in 2.6.38-10 (download speed 1Mbit/0.1MB
> per sec).
> Reverting to 2.6.38-9 kernel restores full Wifi speed (download speed
> 20Mbit/2MB per sec).

... deja vu - and not for the first (or even the second) time!

Mathias (mathias-me) wrote :

I can confirm, Kernel 2.6.38-10 performs very bad, but Kernel 2.6.38-8 works fine. Whatever happened between those releases broke it again.

kdekda (teabof) wrote :

the problem in still present in kernel 3.0

fliebel (zebrametvlekken) wrote :

Fresh install of 11.04, problem still around.

lspci -vnn | grep -A 1 Wireless
10:00.0 Network controller [0280]: Intel Corporation PRO/Wireless 3945ABG [Golan] Network Connection [8086:4222] (rev 02)
 Subsystem: Hewlett-Packard Company Compaq 6710b or nx9420 Notebook [103c:135c]

uname -a
Linux Kast 2.6.38-11-generic #48-Ubuntu SMP Fri Jul 29 19:05:14 UTC 2011 i686 i686 i386 GNU/Linux

Problem seems to be less persistent though. Comes and goes, watching flash movies (youtube) and downloading files in general seems to trigger it. Looks like a buffer overflow or something to me. Re-connecting solves problem untill it shows up again.

Only download speed suffers, upload speed stays constant (as tested on a 50/5mbit connection, an 1/5mbit when the problem show sup).

fliebel (zebrametvlekken) wrote :

dmesg | grep iwl

iwl3945: Intel(R) PRO/Wireless 3945ABG/BG Network Connection driver for Linux, in-tree:s
[ 12.654837] iwl3945: Copyright(c) 2003-2010 Intel Corporation
[ 12.654910] iwl3945 0000:10:00.0: PCI INT A -> GSI 17 (level, low) -> IRQ 17
[ 12.654926] iwl3945 0000:10:00.0: setting latency timer to 64
[ 12.712445] iwl3945 0000:10:00.0: Tunable channels: 13 802.11bg, 23 802.11a channels
[ 12.712449] iwl3945 0000:10:00.0: Detected Intel Wireless WiFi Link 3945ABG
[ 12.714215] iwl3945 0000:10:00.0: irq 46 for MSI/MSI-X
[ 12.777324] ieee80211 phy0: Selected rate control algorithm 'iwl-3945-rs'
[ 20.166763] iwl3945 0000:10:00.0: loaded firmware version 15.32.2.9
[ 20.236486] iwl3945 0000:10:00.0: Error setting Tx power (-5).
[ 2341.235117] iwl3945 0000:10:00.0: Card state received: HW:Kill SW:On
[ 2341.235384] iwl3945 0000:10:00.0: Not sending command - RF KILL
[ 2341.235390] iwl3945 0000:10:00.0: Error sending REPLY_QOS_PARAM: enqueue_hcmd failed: -5
[ 2341.235398] iwl3945 0000:10:00.0: Not sending command - RF KILL
[ 2341.235402] iwl3945 0000:10:00.0: Error sending REPLY_RXON_ASSOC: enqueue_hcmd failed: -5
[ 2341.235412] iwl3945 0000:10:00.0: Not sending command - RF KILL
[ 2341.235417] iwl3945 0000:10:00.0: Error sending REPLY_RXON: enqueue_hcmd failed: -5
[ 2341.235422] iwl3945 0000:10:00.0: Error setting new configuration (-5).
[ 2341.235427] iwl3945 0000:10:00.0: Not sending command - RF KILL
[ 2341.235432] iwl3945 0000:10:00.0: Error sending REPLY_RXON_ASSOC: enqueue_hcmd failed: -5
[ 2341.266107] iwl3945 0000:10:00.0: Not sending command - RF KILL
[ 2341.266120] iwl3945 0000:10:00.0: Error sending REPLY_REMOVE_STA: enqueue_hcmd failed: -5
[ 2341.266129] iwl3945 0000:10:00.0: Error removing station 00:12:17:d5:5f:1d
[ 2341.273129] iwl3945 0000:10:00.0: Not sending command - RF KILL
[ 2341.273141] iwl3945 0000:10:00.0: Error sending REPLY_RXON_ASSOC: enqueue_hcmd failed: -5
[ 2341.273156] iwl3945 0000:10:00.0: Not sending command - RF KILL
[ 2341.273163] iwl3945 0000:10:00.0: Error sending REPLY_RXON: enqueue_hcmd failed: -5
[ 2341.273171] iwl3945 0000:10:00.0: Error setting new configuration (-5).
[ 2341.304589] iwl3945 0000:10:00.0: Not sending command - RF KILL
[ 2341.304595] iwl3945 0000:10:00.0: Error sending REPLY_RXON: enqueue_hcmd failed: -5
[ 2341.304600] iwl3945 0000:10:00.0: Error setting new configuration (-5).
[ 2341.308060] iwl3945 0000:10:00.0: MAC is in deep sleep!. CSR_GP_CNTRL = 0x040003DD
[ 3742.076523] iwl3945 0000:10:00.0: Error setting Tx power (-5).

rfkill list all
0: phy0: Wireless LAN
 Soft blocked: no
 Hard blocked: no
1: hp-wifi: Wireless LAN
 Soft blocked: no
 Hard blocked: no

I just updated to the latest Ubuntu kernel and had the same slow connection that everyone else is reporting.

I downloaded the latest compat-wireless source and followed the same rough instructions I posted in #298:

    $ mkdir -p ~/Downloads/compat-wireless
    $ cd !$
    $ wget http://wireless.kernel.org/download/compat-wireless-2.6/compat-wireless-2011-08-27.tar.bz2
    $ tar -xjvf compat-wireless-2011-08-27.tar.bz2
    $ cd compat-wireless-2011-08-27
    $ ./scripts/driver-select restore
    $ make
    $ sudo make wlunload
    $ sudo make uninstall
    $ sudo make install
    $ sudo modprobe iwl3945

I am having problems with my ISP, but I am happy to report that all is running stably with download speeds comparable to other machines on my network again.
This is not definitive as my speeds are so slow, but I thought I would post them anyway.

$ lspci -vnn | grep -A 1 Wireless
06:00.0 Network controller [0280]: Intel Corporation PRO/Wireless 3945ABG [Golan] Network Connection [8086:4222] (rev 02)
 Subsystem: Intel Corporation PRO/Wireless 3945ABG Network Connection [8086:1000]
 Flags: bus master, fast devsel, latency 0, IRQ 45

$ uname -a
Linux billlaptop 2.6.38-11-generic-pae #48-Ubuntu SMP Fri Jul 29 20:51:21 UTC 2011 i686 i686 i386 GNU/Linux

My ISP finally got my connectivity back to at least to half of what I am paying for so I was able to do some more testing. The results were not favorable, and the compat-wireless-2011-08-27 is still slow again. I was able to recover back to true speeds with compat-wireless-2011-03-18 after performing a minor tweak to an unused file. I don't remember making this change the last time, but it works now so I am passing it on.

Here is the latest set of instructions, again based on #298:

    $ mkdir -p ~/Downloads/compat-wireless/$(uname -r)
    $ cd !$
    $ wget http://wireless.kernel.org/download/compat-wireless-2.6/compat-wireless-2011-03-18.tar.bz2
    $ tar -xjvf compat-wireless-2011-08-27.tar.bz2
    $ cd compat-wireless-2011-08-27
    $ gedit compat/compat-2.6.39.c

        ADD to the bottom of the includes at the top:

            #include <linux/sched.h>

        SAVE
        CLOSE

    $ ./scripts/driver-select restore
    $ make
    $ sudo make wlunload ; sudo make uninstall ; sudo make install ; sudo modprobe iwl3945

Although I am still having problems with my ISP, this seems to be running stably with download speeds comparable to other machines on my network.

$ lspci -vnn | grep -A 1 Wireless
06:00.0 Network controller [0280]: Intel Corporation PRO/Wireless 3945ABG [Golan] Network Connection [8086:4222] (rev 02)
 Subsystem: Intel Corporation PRO/Wireless 3945ABG Network Connection [8086:1000]
 Flags: bus master, fast devsel, latency 0, IRQ 45

$ uname -a
Linux billlaptop 2.6.38-11-generic-pae #48-Ubuntu SMP Fri Jul 29 20:51:21 UTC 2011 i686 i686 i386 GNU/Linux

Oops. Fix the tar and cd commands to use the 2011-03-18 instead of 2011-08-27 in my previous post.

Download full text (3.3 KiB)

I wrote a shell script to download and build each compat-wireless version. I have attached the script for anyone that wants to see it. For maintenance purposes, the script removes the downloaded .bz2 files and any decompressed version that failed to compile with my current setup. I reviewed the logs and noticed starting with compat-wireless-2011-02-23 and running up through compat-wireless-2011-04-14, I was receiving:

   compat-2.6.39.c:93:4: error: ‘TASK_INTERRUPTIBLE’ undeclared (first use in this function)

I already found the fix to this as described in #353, it was simply the addition of "#include <linux/sched.h>" to the file. At this point I had compat-wireless-2011-03-18 working at full speed and compat-wireless-2011-04-26 working with the slow down. I was determined to find the latest version that worked and in turn the first version that didn't. To start, I split the difference and started working on compat-wireless-2011-03-25. With the ‘TASK_INTERRUPTIBLE’ error fix applied, it ran at full speed. Again splitting the difference and working on compat-wireless-2011-03-29, with the ‘TASK_INTERRUPTIBLE’ error fix applied, it ran at full speed. Yet again splitting the difference I began working on compat-wireless-2011-03-31, with the ‘TASK_INTERRUPTIBLE’ error fix applied. However this time it failed to run at full speed. Getting close now. Down to only one left, compat-wireless-2011-03-30 was either going to be the latest that worked or the first that failed. With the ‘TASK_INTERRUPTIBLE’ error fix applied, I saw a new error pop up:

   p54spi.c:652:2: error: implicit declaration of function ‘irq_set_irq_type’

The fix ended up being to copy compat-wireless-2011-03-31/include/linux/compat-2.6.39.h into compat-wireless-2011-03-30. This version compiled now, but failed to run at full speed. The results of my testing are (no annotation = not tested):

   compat-wireless-2011-03-18 Full Speed w/ TASK_INTERRUPTIBLE patch
   compat-wireless-2011-03-19
   compat-wireless-2011-03-20
   compat-wireless-2011-03-21
   compat-wireless-2011-03-22
   compat-wireless-2011-03-23
   compat-wireless-2011-03-24
   compat-wireless-2011-03-25 Full Speed w/ TASK_INTERRUPTIBLE patch
   compat-wireless-2011-03-26
   compat-wireless-2011-03-27
   compat-wireless-2011-03-28
   compat-wireless-2011-03-29 Full Speed w/ TASK_INTERRUPTIBLE patch
   compat-wireless-2011-03-30 Slow Speed w/ TASK_INTERRUPTIBLE patch and new compat-2.6.39.h
   compat-wireless-2011-03-31 Slow Speed w/ TASK_INTERRUPTIBLE patch
   compat-wireless-2011-04-14
   compat-wireless-2011-04-26 Slow Speed

For those of you that have studied computer science, you probably recognized the use of the binary search. For those that haven't and would like some more information about it, take a look at:

   http://en.wikipedia.org/wiki/Binary_search_algorithm

My final analysis is, follow the instructions in #353 and use compat-wireless-2011-03-29 instead of 2011-03-18 or 2011-08-27.

If there is anyone from the compat-wireless folks monitoring this thread, the change that is effecting those of us with an Intel 3945ABG occurred between compat-wireless-2011-03-29 and compat-wireless-2011-03-30. A random sa...

Read more...

The attachment "The patch copied from Redhat's bugzilla. (0002-iwl3945-remove-check_plcp_health)" of this bug report has been identified as being a patch. The ubuntu-reviewers team has been subscribed to the bug report so that they can review the patch. In the event that this is in fact not a patch you can resolve this situation by removing the tag 'patch' from the bug report and editing the attachment so that it is not flagged as a patch. Additionally, if you are member of the ubuntu-sponsors please also unsubscribe the team from this bug report.

[This is an automated message performed by a Launchpad user owned by Brian Murray. Please contact him regarding any issues with the action taken in this bug report.]

tags: added: patch
fv (fratiman-vladut) wrote :

Same problem with intel 3945ABG and kernel 2.38.11
Followed instructions from post #352 with compat-wireless-2011-03-29 and seem to work ok now.
Should be update download link to:
http://linuxwireless.org/download/compat-wireless-2.6/compat-wireless-2011-03-18.tar.bz2

$ uname -a
Linux hp_nx9420 2.6.38-11-generic #48-Ubuntu SMP Fri Jul 29 19:05:14 UTC 2011 i686 i686 i386 GNU/Linux

Andy Barr (ajbarr) wrote :

I tried both compat-wireless-2011-03-18.tar.bz2 and compat-wireless-2011-03-29.tar.bz2 following instructions in comment #353 but I still have a slowdown after a while using the wireless.

I had switched to the ndiswrapper and the windows driver and the speeds were always fine. However, the ndiswrapper with the windows drivers didn't always reconnect to the wireless when the machine comes out of sleep.

Does anyone know if this is fixed in Ubuntu 11.10 with the 3.0 kernel?

@Andy Would you post the output of the following commands:

     lsb_release -rd
     uname -a
     lspci -vnn | grep -A 1 Wireless

Andy Barr (ajbarr) wrote :

William here is the output you requested,

lsb_release -rd
Description: Ubuntu 11.04
Release: 11.04
uname -a
Linux d630 2.6.38-11-generic #50-Ubuntu SMP Mon Sep 12 21:18:14 UTC 2011 i686 i686 i386 GNU/Linux
lspci -vnn | grep -A 1 Wireless
0c:00.0 Network controller [0280]: Intel Corporation PRO/Wireless 3945ABG [Golan] Network Connection [8086:4222] (rev 02)
 Subsystem: Intel Corporation Device [8086:1020]

Is the patch in comment #356 supposed to fix this issue? What commands do I use to apply the patch?

Sarim Khan (sarim2005) wrote :

I was also affected by this bug.

laptop: Hp pavilion dv6000
os : ubuntu 10.10 amd64

 $uname -a
Linux ruet-HP-Pavilion-dv6700-Notebook-PC 2.6.35-22-generic #33-Ubuntu SMP Sun Sep 19 20:32:27 UTC 2010 x86_64 GNU/Linux

Tried ndiswrapper with both xp's and vista's driver, "device not present" not worked.

Then i get this bug after google-ing for hours.

Then compiled and installed compat-wireless-2011-03-18 following the instruction on #353 .
I'm very happy to say that now i am getting full speed from my wifi :D :D :D previously i was getting one fifth to one forth of normal speed.

@Andy
It looks like my instructions may not work for your subsystem, 8086:1020. Nobody that posted success and published their output from the lspci command shows that version. Post #278 had succes with that subsystem and the kernel from #270.

@Sarim
Glad to hear they are working for somebody. The latest one that I have working is version compat-wireless-2011-03-29. There didn't appear to be any changes between these two that effected this specific driver. If you don't feel like testing it out, then there shouldn't be a need to upgrade it.

Sarim Khan (sarim2005) wrote :

@William Thank you.

But i got a bad news, after solving this wifi problem, i installed the propitiatory nvidia driver.
sudo apt-get install nvidia-current
after installing nvidia-current the wifi doesn't connect. It remains in "connecting" state for long time then ask for WEP password again, (same password, saved before). then again "connecting". doesn't connect.
Then i tried adding nvidia.modeset=0 nomodeset to kernel flags. It doesn't help :(

Now if i put my laptop to suspend, then resume after sometime, the wifi connects then. but the speed has dropped again. Not as worst as previous, the speed has decreased :(

I can't realize why it is conflicting with graphics driver :O , but #327 also tells the same things for ati card.

I tried re-compiling iwl3945 module (compat-wireless-2011-03-18). Didn't help.
I'll try compat-wireless-2011-03-29 shortly, will post update then. Any other idea guys ?

I doubt the Nvidia driver did that. Most likely rebooting was what caused that. As it has been mentioned before sometimes it can get normal speeds for some time and then all of a sudden get really slow. Rebooting usually either makes it better or worse.

On 09/30/2011 10:03 PM, Sarim Khan wrote:
> @William Thank you.
>
> But i got a bad news, after solving this wifi problem, i installed the propitiatory nvidia driver.
> sudo apt-get install nvidia-current
> after installing nvidia-current the wifi doesn't connect. It remains in "connecting" state for long time then ask for WEP password again, (same password, saved before). then again "connecting". doesn't connect.
> Then i tried adding nvidia.modeset=0 nomodeset to kernel flags. It doesn't help :(
>
> Now if i put my laptop to suspend, then resume after sometime, the wifi
> connects then. but the speed has dropped again. Not as worst as
> previous, the speed has decreased :(
>
> I can't realize why it is conflicting with graphics driver :O , but #327
> also tells the same things for ati card.
>
> I tried re-compiling iwl3945 module (compat-wireless-2011-03-18). Didn't help.
> I'll try compat-wireless-2011-03-29 shortly, will post update then. Any other idea guys ?
>

Sarim Khan (sarim2005) wrote :

I rebooted after installing wireless driver, i mean executed "sudo reboot" after "sudo make install". It was fully ok then. After that i installed nvidia.

After regenerating initrd couple of times, now it seems ok. it connects in a snap (1-2 seconds). Internet speed is full, but speed in local network seems to be reduced slightly. More or less its ok.

Andy Barr (ajbarr) wrote :

William,
Thanks for the help. Can you or anyone else give me a link on how to apply the patch that is mentioned in #270?
That is this patch, 0001-iwl3945-remove-plcp-check.patch.

Do I apply it to compat-wireless program or the kernel?

Thanks,
Andy

Yann (lostec) wrote :

I also experiment slowdowns under 10.04.3 with 3945ABG, usually after several minutes (5 to 10mn) full speed download (about 700-800 KB/s, upper limit of my ADSL connection, that can be reached with some torrents).

The only thing I notice in syslog is such kind of messages every minute or so:
"possible SYN flooding on port XXX. Sending cookies."

And I don't thing enabling syn cookies will do the trick, imo it's just a symptom of air interface going bad.

I first suspected my ISP doing throttling... but switching to a wired connection and bandwith comes back.

After the problem occurs once, indeed, wireless never returns to nominal performance until a reboot...

my slowdown problem as reported on #344 persists with the new 3.0.0-12-generic kernel

with old compat-wireless as described in #353 i have full speed

but now i see many of these in dmesg, probably the result of hacking up old compat-wireless to run on new kernel is not perfect:

[ 306.571422] iwl3945 0000:04:00.0: Microcode SW error detected. Restarting 0x82000008.
[ 306.571434] iwl3945 0000:04:00.0: Loaded firmware version: 15.32.2.9
[ 306.571471] iwl3945 0000:04:00.0: Start IWL Error Log Dump:
[ 306.571477] iwl3945 0000:04:00.0: Status: 0x0002A2E4, count: 1
[ 306.571483] iwl3945 0000:04:00.0: Desc Time asrtPC blink2 ilink1 nmiPC Line
[ 306.571717] iwl3945 0000:04:00.0: SYSASSERT (0x5) 3345453366 0x008B6 0x13756 0x00320 0x00000 764
[ 306.571721]
[ 306.571854] iwl3945 0000:04:00.0: Start IWL Event Log Dump: display last 20 count
[ 306.571899] iwl3945 0000:04:00.0: 3345452393 0x0000001c 0206
[ 306.571926] iwl3945 0000:04:00.0: 3345452395 0x00400001 0204
[ 306.571952] iwl3945 0000:04:00.0: 3345452400 0x00400001 0219
[ 306.571978] iwl3945 0000:04:00.0: 3345452401 0x00020041 0211
[ 306.572005] iwl3945 0000:04:00.0: 3345452405 0x00000000 0212
[ 306.572033] iwl3945 0000:04:00.0: 3345452736 0x00000000 0215
[ 306.572061] iwl3945 0000:04:00.0: 3345452810 0x00400008 0220
[ 306.572087] iwl3945 0000:04:00.0: 3345452832 0x00000000 0301
[ 306.572113] iwl3945 0000:04:00.0: 3345453102 0x000000d4 0303
[ 306.572140] iwl3945 0000:04:00.0: 3345453305 0x441f0080 0401
[ 306.572166] iwl3945 0000:04:00.0: 3345453320 0x00000017 0452
[ 306.572192] iwl3945 0000:04:00.0: 3345453325 0x00183b6e 0450
[ 306.572218] iwl3945 0000:04:00.0: 3345453330 0x00183b6e 0450
[ 306.572245] iwl3945 0000:04:00.0: 3345453335 0x00183b6e 0450
[ 306.572271] iwl3945 0000:04:00.0: 3345453341 0x00183b6e 0450
[ 306.572297] iwl3945 0000:04:00.0: 3345453346 0x00183b6e 0450
[ 306.572323] iwl3945 0000:04:00.0: 3345453351 0x001c3b6e 0450
[ 306.572349] iwl3945 0000:04:00.0: 3345453356 0x001c3b6e 0450
[ 306.572375] iwl3945 0000:04:00.0: 3345453361 0x001c3b6e 0450
[ 306.572402] iwl3945 0000:04:00.0: 3345453367 0x00000100 0125
[ 306.572432] iwl3945 0000:04:00.0: Error Reply type 0x000002FC cmd REPLY_SCAN_CMD (0x80) seq 0x441F ser 0x00340000
[ 306.577022] iwl3945 0000:04:00.0: Can't stop Rx DMA.
[ 306.577776] ieee80211 phy0: Hardware restart was requested

configuring the iwl3945 module with disable_hw_scan=0 fixes the "speed regression" problem for me on 3.0.0

but i still see the "Microcode SW error detected. Restarting 0x82000008." problem, in regular intervals, either 40 or 100 or 120 seconds

anyone still affected by the "speed regression", try adding the parameters to a file under /etd/modprobe.d, eg:

# cat /etc/modprobe.d/iwl3945.conf
options iwl3945 disable_hw_scan=0

then, with (as root)

modprobe -r iwl3945
modprobe iwl3945

you can hope to better speed

if this helps for you, it would probably be helpful if you could post success/failure here, and along the way i would also be interested is someone sees these "Microcode SW error" issues

please also add the output of

lspci -vnn |grep -A3 Wireless
uname -a
lsb_release -rd

output on my machine:
# lspci -vnn |grep -A3 Wireless; uname -a; lsb_release -rd
04:00.0 Network controller [0280]: Intel Corporation PRO/Wireless 3945ABG [Golan] Network Connection [8086:4227] (rev 02)
        Subsystem: Intel Corporation ThinkPad R60e/X60s [8086:1011]
        Flags: bus master, fast devsel, latency 0, IRQ 46
        Memory at f8000000 (32-bit, non-prefetchable) [size=4K]
Linux sleipnir 3.0.0-12-generic #20-Ubuntu SMP Fri Oct 7 14:56:25 UTC 2011 x86_64 x86_64 x86_64 GNU/Linux
Description: Ubuntu 11.10
Release: 11.10

special thanks go to ... anonymous internet guy who shared this information with me, credit is due to be given to you

regards, gruessle
Simon

nhan cu (nhancu) wrote :

I have a dell inspriron E1505 that uses intel 3945abg..I experienced this internet speed problem when I did clean install of Ubuntu 11.10..I tried a bunch of fixes around the community but nothing helped..I kind of gave up and accepted that I would have to wait for an official patch so that was that. Until I decided I wanted a lighter OS so I did a clean install of Lubuntu 11.10..anyhow, my internet speed is now back to what I paid for with no regression problems like before..

I'm extremely new to linux so I apologize if my assumption is wrong but..I thought since Lubuntu is basically Ubuntu with a different "wrapper"..a developer could look at the differences of the two OS and see what could be causing this bug..

Lino Barreca (linobarreca) wrote :

Solution in post #370 works (almost) for me (i've tried other supposed solutions on internet but nothing worked)
I say almost because on win7 x64 I have speeds of 7540 kbps in download
Before trying steps in post 370 I obtained 721 kbps after I obtained 4566 (so it is at least usable even if not perfect yet)

root@ubuntu:~# lspci -vnn |grep -A3 Wireless
05:00.0 Network controller [0280]: Intel Corporation PRO/Wireless 3945ABG [Golan] Network Connection [8086:4222] (rev 02)
 Subsystem: Intel Corporation Device [8086:1041]
 Flags: bus master, fast devsel, latency 0, IRQ 44
 Memory at f0800000 (32-bit, non-prefetchable) [size=4K]

root@ubuntu:~# uname -a
Linux ubuntu 3.0.0-12-generic #20-Ubuntu SMP Fri Oct 7 14:56:25 UTC 2011 x86_64 x86_64 x86_64 GNU/Linux

root@ubuntu:~# lsb_release -rd
Description: Ubuntu 11.10
Release: 11.10

svengl (sven123) wrote :

Solution in #370 seems to work for me. This is the first fix after YEARS of slow linux wifi (forcing me back to windows)!! And it was so simple....
In the past I was able to recover high speed by disabling and enabling the wifi interface. However, after some minutes it still became slow again.

Maybe one comment for those who cannot find /etc/modprobe.d/iwl3945.conf. It might not be there so simply create it.

Thank you very much

My output:
xxx@ubuntu:/$ lspci -vnn |grep -A3 Wireless
06:00.0 Network controller [0280]: Intel Corporation PRO/Wireless 3945ABG [Golan] Network Connection [8086:4222] (rev 02)
        Subsystem: Intel Corporation Device [8086:1051]
        Flags: bus master, fast devsel, latency 0, IRQ 46
        Memory at cc000000 (32-bit, non-prefetchable) [size=4K]
xxx@ubuntu:/$ uname -a
Linux ubuntu 3.0.0-12-generic #20-Ubuntu SMP Fri Oct 7 14:50:42 UTC 2011 i686 i686 i386 GNU/Linux
xxx@ubuntu:/$ lsb_release -rd
Description: Ubuntu 11.10
Release: 11.10
xxx@ubuntu:/$

svengl (sven123) wrote :

Oh and I also have the Microcode error. It also comes in different intervals.

xxx@ubuntu:/$ dmesg | grep Microcode
[39637.407134] iwl3945 0000:06:00.0: Microcode SW error detected. Restarting 0x82000008.
[39658.562063] iwl3945 0000:06:00.0: Microcode SW error detected. Restarting 0x82000008.
[39698.619779] iwl3945 0000:06:00.0: Microcode SW error detected. Restarting 0x82000008.

lebi gouden (lebigouden) wrote :

Thanks a bunch Simon, i was finally able to solve my problem under Linux Mint Debian Edition x64, with a kernel 3.0.. Sorry to barge in the Ubuntu bug reports, but i had to say thanks.. Actually my download speed has improved even compared to when the wireless card was driving properly, i'll look into hwscan to try and understand what's behind it. I'll be posting to LMDE forums with credits to Simon included of course.

Outputs you were interested in:

lspci -vnn |grep -A3 Wireless
05:00.0 Network controller [0280]: Intel Corporation PRO/Wireless 3945ABG [Golan] Network Connection [8086:4222] (rev 02)
 Subsystem: Intel Corporation Device [8086:1041]
 Flags: bus master, fast devsel, latency 0, IRQ 44
 Memory at da000000 (32-bit, non-prefetchable) [size=4K]
uname -a
Linux gauthierlaptop 3.0.0-1-amd64 #1 SMP Sun Jul 24 02:24:44 UTC 2011 x86_64 GNU/Linux

Linux Mint Debian release 1.

Sava (sava-f) wrote :

Thanks Simon! Solution in #370 seems to work for me

root@laptop:~# lspci -vnn |grep -A3 Wireless
02:00.0 Network controller [0280]: Intel Corporation PRO/Wireless 3945ABG [Golan] Network Connection [8086:4222] (rev 02)
 Subsystem: Intel Corporation Device [8086:1041]
 Flags: bus master, fast devsel, latency 0, IRQ 43
 Memory at ffaff000 (32-bit, non-prefetchable) [size=4K]
root@laptop:~# uname -a
Linux laptop 3.0.0-12-generic #20-Ubuntu SMP Fri Oct 7 14:56:25 UTC 2011 x86_64 x86_64 x86_64 GNU/Linux
root@laptop:~# lsb_release -rd
Description: Ubuntu 11.10
Release: 11.10

picomike (picomike) wrote :

I've using it for a week and I can say workaround in #370 is doing great in my laptop with Ubuntu 11.10. Thank you Simon. A lot.

lspci -vnn |grep -A3 Wireless
05:00.0 Network controller [0280]: Intel Corporation PRO/Wireless 3945ABG [Golan] Network Connection [8086:4222] (rev 02)
 Subsystem: Intel Corporation PRO/Wireless 3945ABG Network Connection [8086:1001]
 Flags: bus master, fast devsel, latency 0, IRQ 45
 Memory at d2100000 (32-bit, non-prefetchable) [size=4K]
 Capabilities: [c8] Power Management version 2

uname -a
Linux GoldorakLapUb 3.0.0-12-generic #20-Ubuntu SMP Fri Oct 7 14:50:42 UTC 2011 i686 i686 i386 GNU/Linux

Konrad (konradmb) wrote :
Download full text (3.6 KiB)

Simon, thanks for workaround. It works great!
This bug should be nominated to oneiric. Looks like regression for me. I've never had problems with this card from my first version of Ubuntu: 8.04! Since I've upgraded from 11.04 to 11.10 I'm getting this error:
Nov 3 20:05:14 konrad-laptop kernel: [14766.903244] iwl3945 0000:03:00.0: Microcode SW error detected. Restarting 0x82000008.
Nov 3 20:05:14 konrad-laptop kernel: [14766.903254] iwl3945 0000:03:00.0: Loaded firmware version: 15.32.2.9
Nov 3 20:05:14 konrad-laptop kernel: [14766.903290] iwl3945 0000:03:00.0: Start IWL Error Log Dump:
Nov 3 20:05:14 konrad-laptop kernel: [14766.903296] iwl3945 0000:03:00.0: Status: 0x0002A2E4, count: 1
Nov 3 20:05:14 konrad-laptop kernel: [14766.903301] iwl3945 0000:03:00.0: Desc Time asrtPC blink2 ilink1 nmiPC Line
Nov 3 20:05:14 konrad-laptop kernel: [14766.903530] iwl3945 0000:03:00.0: SYSASSERT (0x5) 0001830343 0x008B6 0x13756 0x00320 0x00000 764
Nov 3 20:05:14 konrad-laptop kernel: [14766.903533]
Nov 3 20:05:14 konrad-laptop kernel: [14766.903663] iwl3945 0000:03:00.0: Start IWL Event Log Dump: display last 20 count
Nov 3 20:05:14 konrad-laptop kernel: [14766.903706] iwl3945 0000:03:00.0: 0001830107 0x00000000 1106
Nov 3 20:05:14 konrad-laptop kernel: [14766.903731] iwl3945 0000:03:00.0: 0001830111 0x00000000 1106
Nov 3 20:05:14 konrad-laptop kernel: [14766.903756] iwl3945 0000:03:00.0: 0001830116 0x00000000 1106
Nov 3 20:05:14 konrad-laptop kernel: [14766.903781] iwl3945 0000:03:00.0: 0001830120 0x00000000 1106
Nov 3 20:05:14 konrad-laptop kernel: [14766.903806] iwl3945 0000:03:00.0: 0001830124 0x00000000 1106
Nov 3 20:05:14 konrad-laptop kernel: [14766.903831] iwl3945 0000:03:00.0: 0001830128 0x00000000 1106
Nov 3 20:05:14 konrad-laptop kernel: [14766.903856] iwl3945 0000:03:00.0: 0001830133 0x00000000 1106
Nov 3 20:05:14 konrad-laptop kernel: [14766.903881] iwl3945 0000:03:00.0: 0001830137 0x00000000 1106
Nov 3 20:05:14 konrad-laptop kernel: [14766.903906] iwl3945 0000:03:00.0: 0001830141 0x00000001 1106
Nov 3 20:05:14 konrad-laptop kernel: [14766.903931] iwl3945 0000:03:00.0: 0001830142 0x0000000f 1106
Nov 3 20:05:14 konrad-laptop kernel: [14766.903955] iwl3945 0000:03:00.0: 0001830144 0x00000412 1105
Nov 3 20:05:14 konrad-laptop kernel: [14766.903980] iwl3945 0000:03:00.0: 0001830147 0x00000473 1115
Nov 3 20:05:14 konrad-laptop kernel: [14766.904005] iwl3945 0000:03:00.0: 0001830151 0x00000001 0463
Nov 3 20:05:14 konrad-laptop kernel: [14766.904030] iwl3945 0000:03:00.0: 0001830152 0x00000001 0462
Nov 3 20:05:14 konrad-laptop kernel: [14766.904056] iwl3945 0000:03:00.0: 0001830288 0x44130080 0401
Nov 3 20:05:14 konrad-laptop kernel: [14766.904081] iwl3945 0000:03:00.0: 0001830302 0x00000017 0452
Nov 3 20:05:14 konrad-laptop kernel: [14766.904106] iwl3945 0000:03:00.0: 0001830328 0x00103b6e 0450
Nov 3 20:05:14 konrad-laptop kernel: [14766.904131] iwl3945 0000:03:00.0: 0001830334 0x00103b6e 0450
Nov 3 20:05:14 konrad-laptop kernel: [14766.904155] iwl3945 0000:03:00.0: 0001830339 0x00103b6e 0450
Nov 3 20:05:14 konrad-laptop kernel: [14766.904180] iwl3945 0000:03:00.0: 0001830345 0x00000100 0125
Nov 3 ...

Read more...

Thank you Simon for the fix at #370 This was something I noticed for over a year, but thought it was because my crappy router/dsl connection. BTW my hardware is an ASUS Z53 Laptop. Core2Duo 5600 (Motherboard same as model F3JC)

My output:

lspci -vnn | grep -A3 Wireless
03:00.0 Network controller [0280]: Intel Corporation PRO/Wireless 3945ABG [Golan] Network Connection [8086:4222] (rev 02)
 Subsystem: Intel Corporation PRO/Wireless 3945ABG Network Connection [8086:1001]
 Flags: bus master, fast devsel, latency 0, IRQ 46
 Memory at fe1ff000 (32-bit, non-prefetchable) [size=4K]
 Capabilities: <access denied>

/etc/modprobe.d$ uname -a
Linux christo-F3JC 3.0.0-12-generic #20-Ubuntu SMP Fri Oct 7 14:56:25 UTC 2011 x86_64 x86_64 x86_64 GNU/Linux

/etc/modprobe.d$ dmesg | grep Microcode
[ 2717.563846] iwl3945 0000:03:00.0: Microcode SW error detected. Restarting 0x82000008.
[ 2738.636685] iwl3945 0000:03:00.0: Microcode SW error detected. Restarting 0x82000008.
[ 2778.592868] iwl3945 0000:03:00.0: Microcode SW error detected. Restarting 0x82000008.
[ 2838.630153] iwl3945 0000:03:00.0: Microcode SW error detected. Restarting 0x82000008.
[ 2918.634217] iwl3945 0000:03:00.0: Microcode SW error detected. Restarting 0x82000008.

Sidebar: This issue is one I only had with Alice routers (1121 -- German description: http://www.alice-wiki.de/Alice_Modem_1121_WLAN ) at my friend's places. No issues whatsoever with Linksys WRT54GL routers at my home or work.

Anyhow, Simon's fix ( https://bugs.launchpad.net/ubuntu/+source/linux/+bug/621265/comments/370 ) also helped in my case as well, so kudos for that.

Yet it seems now that my speed randomly alternates between 300kb/s and 1,400kb/s (max speed possible) but I rather have it this way than for it to shortly burst at top speed only so it drops down to around 120kb/s.

Here's my system data:

# lspci -vnn |grep -A3 Wireless
03:00.0 Network controller [0280]: Intel Corporation PRO/Wireless 3945ABG [Golan] Network Connection [8086:4227] (rev 02)
 Subsystem: Intel Corporation ThinkPad R60e/X60s [8086:1011]
 Physical Slot: 3
 Flags: bus master, fast devsel, latency 0, IRQ 45

# uname -a
Linux demona 3.0.0-12-generic #20-Ubuntu SMP Fri Oct 7 14:50:42 UTC 2011 i686 i686 i386 GNU/Linux

# lsb_release -rd
Description: Ubuntu 11.10
Release: 11.10

Hi guys

just to clarify, it was not me who found out about "disable_hw_scan=0", but the guy who let me know about it wanted to remain anonymous.
Anyways, I am glad it helps.

Btw, I removed network-manager completely and replaced it by wicd, did not see a single "Microcode SW error detected. Restarting 0x82000008." since then.

I can live without network-manager on this machine if it means the kernel log is not spamed ad nauseam.

Gruessle
Simon

Andy Barr (ajbarr) wrote :

On my Ubunt 11.04 machine, I installed
linux-backports-modules-cw-3.0.0-natty-generic

which gave me the new wireless modules without having to update to the latest Linux 3.0 kernel.

I also had to setup the "disable_hw_scan=0" as described in #370.
creaate this file,

/etc/modprobe.d/iwl3945.conf

and put this into it.
options iwl3945 disable_hw_scan=0

So far no more speed slowdowns.

Here are my system details,
lspci -vnn |grep -A3 Wireless
0c:00.0 Network controller [0280]: Intel Corporation PRO/Wireless 3945ABG [Golan] Network Connection [8086:4222] (rev 02)
 Subsystem: Intel Corporation Device [8086:1020]
 Flags: bus master, fast devsel, latency 0, IRQ 47
 Memory at f6cff000 (32-bit, non-prefetchable) [size=4K]

uname -a
Linux d630 2.6.38-12-generic #51-Ubuntu SMP Wed Sep 28 14:25:20 UTC 2011 i686 i686 i386 GNU/Linux

lsb_release -rd
Description: Ubuntu 11.04
Release: 11.04
Thanks for everyone who posted their information to help figure out this issue.

I thought I'd share my experience with this bug. When I upgraded to Ubuntu 11.10 I discovered I had a slow wireless connection, and after a bit of searching around found this page. The disable_hw_scan=0 fix in #370 seemed to fix my problem, but like others I was getting loads of "Microcode SW error detected" errors.

But after applying the fix I started to have problems with Ubuntu freezing occasionally. Everything would just stop working, and I'd have to do a hard reset by holding down my laptop's power button. This happened several times over a week or two, and I'd had enough when it happened twice in one day. So I decided to remove the /etc/modprobe.d/iwl3945.conf file I'd created to undo the fix. And afterwards the crashes stopped, though obviously I was left with slow wi-fi. But I decided to live with it and gave up looking for a fix, hoping a future update would fix things.

Last night though I got impatient and started looking again. Long story short, I decided to try using Wicd instead of NetworkManager. And since then things seem to be working fine, my wireless speeds are back to normal, perhaps even slightly better than when I had the disable_hw_scan=0 fix applied. Just to reiterate, I removed the fix before installing Wicd and don't have it applied now, so the bug appears to be with NetworkManager, or at least in my case it does. Perhaps other people who have had this issue since upgrading to 11.10 (and I had never had a wireless issue since I started using Ubuntu 3+ years ago) could try using Wicd and see if it fixes things for them too.

Here's my system specs:
lspci -vnn |grep -A3 Wireless
0c:00.0 Network controller [0280]: Intel Corporation PRO/Wireless 3945ABG [Golan] Network Connection [8086:4222] (rev 02)
 Subsystem: Intel Corporation Device [8086:1021]
 Flags: bus master, fast devsel, latency 0, IRQ 45
 Memory at f9fff000 (32-bit, non-prefetchable) [size=4K]

uname -a
Linux cdowning-laptop 3.0.0-13-generic #22-Ubuntu SMP Wed Nov 2 13:27:26 UTC 2011 x86_64 x86_64 x86_64 GNU/Linux

lsb_release -rd
Description: Ubuntu 11.10
Release: 11.10

Changed in linux:
status: Confirmed → Won't Fix

I have (probably) the same problem on a Thinkpad T60 with iwl3945. When I modprobe the iwl3945 module, I have full speed for around 5-10 seconds and then it breaks down to 0. I can still use the network, browse and open ssh connections but opening pages is slow on firefox and ssh connections freeze after I receive a lot of data fast (eg. cat'ing a logfile).

rmmod & modprobe iwl3945 starts the circle again.

Already tried module options disable_hw_scan=0, swcrypto=0: No difference.

Tried it with linux-backports-modules-cw-3.1-oneiric-generic: no difference.

Wireless is almost unusable right now.

Aleksei (tav-susp) wrote :

Sebastian Wiesinger (sebastianw) wrote on 2012-01-06:
the same. Acer Aspire 5670, at MS Windows it works just fine - where is that good driver???(((

Sam_ (and-sam) on 2012-01-29
tags: added: oneiric
Andy Barr (ajbarr) wrote :

Sebastian and Aleksei,
Can you run the following commands from a terminal and provide the following output?

lspci -vnn |grep -A3 Wireless
uname -a
lsb_release -rd

I was told that there are a few different issues depending on what subsytem your machine has.

I was very frustrated with this bug also. I finally got it resolved and posted my details in comment #382.

sebastian@gucky:~$ lspci -vnn |grep -A3 Wireless
03:00.0 Network controller [0280]: Intel Corporation PRO/Wireless 3945ABG [Golan] Network Connection [8086:4227] (rev 02)
 Subsystem: Intel Corporation Device [8086:1010]
 Physical Slot: 3
 Flags: bus master, fast devsel, latency 0, IRQ 49
sebastian@gucky:~$ uname -a
Linux gucky 3.0.0-15-generic #26-Ubuntu SMP Fri Jan 20 15:59:53 UTC 2012 i686 i686 i386 GNU/Linux
sebastian@gucky:~$ lsb_release -rd
Description: Ubuntu 11.10
Release: 11.10

Dvanzo (danielvanzo) wrote :

I'm very frustrated too... The "Won't Fix" status didn't make me happy neither...

Just in case, my info:

dvanzo@dvanzo-Vostro-1500:~$ lspci -vnn |grep -A3 Wireless
0c:00.0 Network controller [0280]: Intel Corporation PRO/Wireless 3945ABG [Golan] Network Connection [8086:4222] (rev 02)
 Subsystem: Intel Corporation Device [8086:1020]
 Flags: bus master, fast devsel, latency 0, IRQ 44
 Memory at f9fff000 (32-bit, non-prefetchable) [size=4K]

Krupka Michal (normanjp-cz) wrote :

Workaround #372 worked for me as well. No more speed drops since then. Big thx to Simon and his source.

Just a little note. If you have your wireless network with hidden SSID, it can take long time to connect to the network after being disconnected (long time means ~25mins, at least in my case).

info

lspci -vnn |grep -A3 Wireless
02:00.0 Network controller [0280]: Intel Corporation PRO/Wireless 3945ABG [Golan] Network Connection [8086:4222] (rev 02)
 Subsystem: Intel Corporation PRO/Wireless 3945ABG Network Connection [8086:1001]
 Flags: bus master, fast devsel, latency 0, IRQ 43
 Memory at fdfff000 (32-bit, non-prefetchable) [size=4K]
 Capabilities: <access denied>

uname -a
Linux manronF3F 3.2.0-17-generic-pae #27-Ubuntu SMP Fri Feb 24 15:59:25 UTC 2012 i686 i686 i386 GNU/Linux

lsb_release -rd
Description: Ubuntu precise (development branch)
Release: 12.04

Andy Barr (ajbarr) wrote :

Dvanzo,
In comment #362 was told that the fixes are specific for a subsystem. You have the same subsystem that I have, 8086:1020 so my fix in #382 should work for you. If you are on Ubuntu version 11.10 then I think all you need to do is setup the "disable_hw_scan=0" as described in #370.
creaate this file,

/etc/modprobe.d/iwl3945.conf

and put this into it.
options iwl3945 disable_hw_scan=0

If you are on 11.04 as I am then you need to follow all my instructions in #370.

If that doesn't fix the issue, try downloading a live CD and boot the live CD of 11.11 and see if you can apply the changes. When I was trying to fix this, I had made so many changes that I need to go back to the beginning and start over.

Comment #383, he mentions not using the /etc/modprobe.d/iwl3945.conf file and just removing NetWorkmananger and installing WICD instead. I did not try that as I didn't want to loose a VPN I had configured in NetWork manager.

Andy Barr (ajbarr) wrote :

Sebastian,
I have a different subsystem then you. Search in this bug for people with the same subsystem,
"Intel Corporation Device [8086:1010]" as you have and see what they did to get it to work.

If you have made a lot of changes, I would also suggest starting over and booting a live CD and try to apply the fixes to the live CD to see if you can get something to work. I had made so many changes I had lost track and starting over with the live CD helped me solve my problem.

Brad Figg (brad-figg) on 2012-04-03
tags: added: kernel-wifi
fv (fratiman-vladut) wrote :

I confirm that replacing NetworkManager with Wicd resolv problems with slow speed on my wifi intel 3945ABG

wifi card spec:
10:00.0 Network controller [0280]: Intel Corporation PRO/Wireless 3945ABG [Golan] Network Connection [8086:4222] (rev 02)

System: Linux Mint Kathya

Kernel: 2.6.38-14-generic

Dvanzo (danielvanzo) wrote :

Arghhhh!!! I gave up with 10.10... So I'm testing now 12.04... IT'S WORST!!!! Now I can connect barely at 20Kb/s!!!!! I cant believe it!!! Tried different things without luck...

My new info:

uname -a
Linux dvanzo-Vostro-1500 3.2.0-24-generic-pae #37-Ubuntu SMP Wed Apr 25 10:47:59 UTC 2012 i686 i686 i386 GNU/Linux

lsb_release -rd
Description: Ubuntu 12.04 LTS
Release: 12.04

lspci -vnn |grep -A3 Wireless
0c:00.0 Network controller [0280]: Intel Corporation PRO/Wireless 3945ABG [Golan] Network Connection [8086:4222] (rev 02)
 Subsystem: Intel Corporation Device [8086:1020]
 Flags: bus master, fast devsel, latency 0, IRQ 45
 Memory at f9fff000 (32-bit, non-prefetchable) [size=4K]

lsmod|grep iwl3945
iwl3945 73152 0
iwl_legacy 71134 1 iwl3945
mac80211 436455 2 iwl3945,iwl_legacy
cfg80211 178679 3 iwl3945,iwl_legacy,mac80211

iwconfig
lo no wireless extensions.

wlan0 IEEE 802.11abg ESSID:"ACCESS01"
          Mode:Managed Frequency:2.412 GHz Access Point: 00:22:33:FC:6A:50
          Bit Rate=18 Mb/s Tx-Power=15 dBm
          Retry long limit:7 RTS thr:off Fragment thr:off
          Power Management:off
          Link Quality=70/70 Signal level=-35 dBm
          Rx invalid nwid:0 Rx invalid crypt:0 Rx invalid frag:0
          Tx excessive retries:0 Invalid misc:680 Missed beacon:0

Any idea?

Regards,

Daniel

It has been some time since I posted here, but I finally took the time to update to 12.04. I did a clean install and had the same slow Wi-Fi problem out of the box. So I can confirm that Bug #621265 affects Ubuntu 12.04 Precise Pangolin too. I then did the same change documented previously of removing NetworkManager and installing Wicd. All is working once again. All that said, this appears to not be a GNU/Linux, driver, or Ubuntu issue rather a Network Manager package issue since the bug is so easily fixed by merely replacing that package with a comparable one.

Here are the steps I performed:

NOTE: Plug in a wired ethernet connection while completing these steps or reverse the order of the next two steps if one is not available.

$ sudo apt-get remove network-manager
$ sudo apt-get install wicd

NOTE: To get the SysTray Icon to show up, you have to follow the tip from here:

   http://ubuntuforums.org/showthread.php?t=1762663

$ gsettings set com.canonical.Unity.Panel systray-whitelist "['all']"

NOTE: Or for a more involved, probably more correct, way to get the SysTray Icon to show up, follow the steps here:

   https://bugs.launchpad.net/wicd/+bug/761326/comments/2

Reboot and log back in. You will have to reenter all of your saved network credientials, so it is a good idea to swap managers as soon as the need is identified.

Just for the record, here is my upgraded system specs:

$ lsb_release -rd
Description: Ubuntu 12.04 LTS
Release: 12.04

$ uname -a
Linux bill-laptop 3.2.0-25-generic-pae #40-Ubuntu SMP Wed May 23 22:11:24 UTC 2012 i686 i686 i386 GNU/Linux

$ lspci -vnn | grep -A 1 Wireless
06:00.0 Network controller [0280]: Intel Corporation PRO/Wireless 3945ABG [Golan] Network Connection [8086:4222] (rev 02)
 Subsystem: Intel Corporation PRO/Wireless 3945ABG Network Connection [8086:1000]
 Flags: bus master, fast devsel, latency 0, IRQ 45

Radosław Piliszek (radzio) wrote :

I've been inactive for a long time but here I come again and see people still having the same problem.
I was one of the first (if not the first) to discover that Network Manager was causing or at least augmenting the problem. It's a pity neither Network Manager's nor Intel's team did anything to move this issue further. ;-(
The fact is that going without Network Manager makes it impossible to reproduce the bug. The question is why it affects iwl3945 and not other cards like iwl4965? Or maybe no one knows because the drop isn't that big?

Eric Appleman (erappleman) wrote :

Since I'm using my spare again, I figured I'd chime in.

I get my full 22Mbps with Precise/Quantal.

Not sure about older releases.

Declined for Maverick as EOL -> Won't Fix.

tags: added: needs-kernel-logs
Changed in linux (Ubuntu Maverick):
status: Incomplete → Invalid

Errico Picchiarelli, this bug was reported a while ago and there hasn't been any activity in it recently. We were wondering if this is still an issue? If so, could you please test for this with the latest development release of Ubuntu? ISO images are available from http://cdimage.ubuntu.com/daily-live/current/ .

If it remains an issue, could you please run the following command in the development release from a Terminal (Applications->Accessories->Terminal), as it will automatically gather and attach updated debug information to this report:

apport-collect -p linux <replace-with-bug-number>

Also, could you please test the latest upstream kernel available following https://wiki.ubuntu.com/KernelMainlineBuilds ? It will allow additional upstream developers to examine the issue. Please do not test the daily folder, but the one all the way at the bottom. Once you've tested the upstream kernel, please comment on which kernel version specifically you tested. If this bug is fixed in the mainline kernel, please add the following tags:
kernel-fixed-upstream
kernel-fixed-upstream-VERSION-NUMBER

where VERSION-NUMBER is the version number of the kernel you tested. For example:
kernel-fixed-upstream-v3.11-rc5

This can be done by clicking on the yellow circle with a black pencil icon next to the word Tags located at the bottom of the bug description. As well, please remove the tag:
needs-upstream-testing

If the mainline kernel does not fix this bug, please add the following tags:
kernel-bug-exists-upstream
kernel-bug-exists-upstream-VERSION-NUMBER

As well, please remove the tag:
needs-upstream-testing

If you are unable to test the mainline kernel, please comment as to why specifically you were unable to test it and add the following tags:
kernel-unable-to-test-upstream
kernel-unable-to-test-upstream-VERSION-NUMBER

Once testing of the upstream kernel is complete, please mark this bug's Status as Confirmed. Please let us know your results. Thank you for your understanding.

Changed in linux (Ubuntu):
status: Confirmed → Incomplete
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers

Remote bug watches

Bug watches keep track of this bug in other bug trackers.